class JobCountDashboard < RxModule::Dashboards::CategoryChart
  expose('rx_job_count', 'Job Tracker Station Count', 'Tracks job count at stations in Rx-Universe')
  targets("Stations", "Which station(s) to pull job counts from", -> { station_dropdown_values })

  ui_hint(category: 'Job Tracker')

  def build_results!
    RxModule::Communicator::Rxuniverse.job_count_at_station.each do |station|
      if is_target? station[:code]
        push_point('stations', station[:count], station[:code])
      end
    end
  end

  def series_name(id)
    "Stations"
  end

  def standard_category_names
    JobCountDashboard.standard_category_names
  end

  class << self
    def standard_category_names
      begin
        RxModule::Communicator::Rxuniverse.job_tracker_stations.map do |s|
          [s[:code], s[:desc]]
        end.to_h
      rescue StandardError => err
        {}
      end
    end

    def station_dropdown_values
      standard_category_names.map do |k, v|
        {label: v, value: k}
      end
    end
  end
end