class LateJobList < RxModule::Dashboards::Table
  expose('rx_late_list', 'Late Job List', 'Lists open late jobs')
  column('order-days-late', 'Days Late', 'integer')
  column('order-number', 'Number', 'string')
  column('order-account-num', 'Account', 'string')
  column('ord-cust-job-id', 'Customer Job ID', 'string')
  column('order-status-station', 'Station', 'string')
  column('order-status-cust-desc', 'Station Customer Description', 'string')
  column('order-date-time', 'Status Updated', 'datetime')
  column('ord-wanted-date', 'Wanted', 'date')

  ui_hint(default_sorts: [{id: 'order-days-late', desc: true}, {id: 'order-account-num', desc: true}])
  ui_hint(category: 'Jobs')

  def build_results!
    RxModule::Communicator::Rxuniverse.late_jobs.each do |job|
      add_row({
                  **job,
                  'order-days-late': job[:'order-days-late'].to_i,
                  'order-date-time': RxModule::Time.resolve(Time.strptime("#{job[:'order-status-date']} #{job[:'order-status-time']}", '%Y%m%d %H%M')).strftime('%Y-%m-%d %H:%M'),
                  'ord-wanted-date': RxModule::Time.resolve(Time.strptime(job[:'ord-wanted-date'], '%Y%m%d')).strftime('%Y-%m-%d')
              })
    end
  end
end