class WipGaugeDashboard < RxModule::Dashboards::Gauge
  expose('rx_wip_gauge', 'WIP Gauge', 'Tracks wip jobs in Rx-Universe')
  targets("Metric", "Choose which WIP state(s) to monitor", -> { metric_dropdown_values })
  metric(:'jobs-wip-yesterday', 'WIP Yesterday', true)
  metric(:'jobs-in', 'Jobs In', true)
  metric(:'jobs-out', 'Jobs Out', true)
  metric(:'jobs-wip', 'WIP', true)
  metric(:'jobs-brk', 'Breaks (Job Count)', false)
  metric(:'jobs-brk-%', 'Breaks (% Total Jobs)', false)
  metric(:'jobs-cancelled', 'Cancelled', false)
  ui_hint(category: 'WIP')

  def build_results!
    wip = RxModule::Communicator::Rxuniverse.current_wip
    total = RxModule::Communicator::Rxuniverse.wip_breakdown[:'num-total'].to_f
    targets.each do |target|
      if target.to_s == 'jobs-brk-%'
        if total == 0
          set_metric(:'jobs-brk-%', 0)
        else
          set_metric(:'jobs-brk-%', ((wip[:'jobs-brk'].to_f / total) * 100).round(2))
        end
      else
        set_metric(target.to_sym, wip[target.to_sym].to_f)
      end
    end
  end

  def self.metrics
    super
  end
end