# == Schema Information
#
# Table name: file_monitor_configs
#
#  id                 :bigint           not null, primary key
#  archive_age        :integer
#  archive_directory  :string
#  error_directory    :string
#  incoming_directory :string
#  created_at         :datetime         not null
#  updated_at         :datetime         not null
#
class FileMonitorConfig < ApplicationRecord
  before_create do
    self.errors.add(:base, "already one setting object existing") and return false if FileMonitorConfig.exists?
  end
  after_save :run_monitor

  class << self
    def instance
      first_or_create!(incoming_directory: File.exist?('c:\rxuniverse\xmlfile') ? 'c:\rxuniverse\xmlfile' : Rails.root.join('xml', 'incoming'),
                       archive_directory: Rails.root.join('xml', 'archive'),
                       error_directory: Rails.root.join('xml', 'error'),
                       archive_age: 14)
    end

    def run_monitor
      instance.run_monitor
    end
  end

  def run_monitor
    FileMonitor.run_monitor(incoming_directory)
  end
end
