# == Schema Information
#
# Table name: orders
#
#  id                      :bigint           not null, primary key
#  accountnum              :string
#  arcode                  :string
#  arcost                  :decimal(12, 3)
#  ardesc                  :string
#  arflag                  :boolean
#  arprice                 :decimal(12, 3)
#  backcode                :string
#  backcost                :decimal(12, 3)
#  backdesc                :string
#  backflag                :boolean
#  backprice               :decimal(12, 3)
#  billtoaddr1             :string
#  billtoaddr2             :string
#  billtoaddr3             :string
#  billtoaddr4             :string
#  billtogroup             :string
#  billtoname              :string
#  billtonum               :string
#  billtophone             :string
#  datetimecompleted       :datetime
#  datetimeframereceived   :datetime
#  datetimereceived        :datetime
#  datetimewanted          :datetime
#  digitalclickfee         :decimal(12, 3)
#  envelopenum             :string
#  hotjobflag              :boolean
#  invoicetotal            :decimal(12, 3)
#  jobtype                 :string
#  labnum                  :string           not null
#  lmssource               :string           not null
#  ltadd                   :float
#  ltaxis                  :integer
#  ltbasecurve             :float
#  ltbasetool              :float
#  ltbinlocation           :string
#  ltblankdiam             :integer
#  ltblankmanuf            :string
#  ltblanksforf            :string
#  ltblankthick            :float
#  ltboc                   :float
#  ltbowlsize              :integer
#  ltbsd                   :float
#  ltbsi                   :float
#  ltcarrier               :float
#  ltcolor                 :string
#  ltcolorcode             :string
#  ltcrosstool             :float
#  ltcylinder              :float
#  ltdepth                 :integer
#  ltdigitalvendor         :string
#  ltlenscost              :decimal(12, 3)
#  ltlensprice             :decimal(12, 3)
#  ltlenstype              :string
#  ltlnam                  :string
#  ltmaterial              :string
#  ltmaterialcode          :string
#  ltnearpd                :float
#  ltocht                  :float
#  ltopc                   :string
#  ltpd                    :float
#  ltpretreatment          :string
#  ltpretreatmentcode      :string
#  ltprism                 :float
#  ltprism2                :float
#  ltprismdirn             :float
#  ltprismdirn2            :float
#  ltrequestedbase         :string
#  ltrequesteddiam         :string
#  ltrequestedkind         :string
#  ltrequestedmanuf        :string
#  ltseght                 :float
#  ltsku                   :string
#  ltsphere                :float
#  ltstyle                 :string
#  ltstylecode             :string
#  ltthick                 :float
#  ltuncutdiam             :float
#  ltuncutellh             :float
#  ltupperadd              :float
#  ltverticaldecent        :float
#  ltwidth                 :integer
#  mirrcode                :string
#  mirrcost                :decimal(12, 3)
#  mirrdesc                :string
#  mirrflag                :boolean
#  mirrprice               :decimal(12, 3)
#  numberdaysframereceived :integer
#  numbreakages            :integer
#  numdayslate             :integer
#  orderblanksforf         :string
#  ordercolor              :string
#  ordercolorcode          :string
#  orderdigitalvendor      :string
#  orderlenstype           :string
#  orderlnam               :string
#  ordermaterial           :string
#  ordermaterialcode       :string
#  ordernum                :string           not null
#  orderponum              :string
#  orderpretreatment       :string
#  orderpretreatmentcode   :string
#  ordersource             :string
#  orderstyle              :string
#  orderstylecode          :string
#  patientname             :string
#  photcode                :string
#  photdesc                :string
#  photflag                :boolean
#  polishcode              :string
#  polishcost              :decimal(12, 3)
#  polishdesc              :string
#  polishflag              :boolean
#  polishprice             :decimal(12, 3)
#  polzcode                :string
#  polzcost                :decimal(12, 3)
#  polzdesc                :string
#  polzflag                :boolean
#  polzprice               :decimal(12, 3)
#  releasenum              :string
#  remakecode              :string
#  remakeflag              :boolean
#  remakeoriginvnum        :string
#  remakereason            :string
#  rtadd                   :float
#  rtaxis                  :integer
#  rtbasecurve             :float
#  rtbasetool              :float
#  rtbinlocation           :string
#  rtblankdiam             :integer
#  rtblankmanuf            :string
#  rtblanksforf            :string
#  rtblankthick            :float
#  rtboc                   :float
#  rtbowlsize              :integer
#  rtbsd                   :float
#  rtbsi                   :float
#  rtcarrier               :float
#  rtcolor                 :string
#  rtcolorcode             :string
#  rtcrosstool             :float
#  rtcylinder              :float
#  rtdepth                 :integer
#  rtdigitalvendor         :string
#  rtlenscost              :decimal(12, 3)
#  rtlensprice             :decimal(12, 3)
#  rtlenstype              :string
#  rtlnam                  :string
#  rtmaterial              :string
#  rtmaterialcode          :string
#  rtnearpd                :float
#  rtocht                  :float
#  rtopc                   :string
#  rtpd                    :float
#  rtpretreatment          :string
#  rtpretreatmentcode      :string
#  rtprism                 :float
#  rtprism2                :float
#  rtprismdirn             :float
#  rtprismdirn2            :float
#  rtrequestedbase         :string
#  rtrequesteddiam         :string
#  rtrequestedkind         :string
#  rtrequestedmanuf        :string
#  rtseght                 :float
#  rtsku                   :string
#  rtsphere                :float
#  rtstyle                 :string
#  rtstylecode             :string
#  rtthick                 :float
#  rtuncutdiam             :float
#  rtuncutellh             :float
#  rtupperadd              :float
#  rtverticaldecent        :float
#  rtwidth                 :integer
#  salesmancode            :string
#  shipmethod              :string
#  shiptoaddr1             :string
#  shiptoaddr2             :string
#  shiptoaddr3             :string
#  shiptoaddr4             :string
#  shiptogroup             :string
#  shiptoname              :string
#  shiptonum               :string
#  shiptophone             :string
#  shiptozip               :string
#  shiptracking            :string
#  subtotal                :decimal(12, 3)
#  timezonediff            :float
#  tintcode                :string
#  tintcost                :decimal(12, 3)
#  tintdesc                :string
#  tintflag                :boolean
#  tintprice               :decimal(12, 3)
#  totaladdonprice         :decimal(12, 3)
#  tracea                  :float
#  traceb                  :float
#  tracecirc               :float
#  tracedbl                :float
#  traceed                 :float
#  traceframetype          :string
#  tracemanuf              :string
#  tracemodel              :string
#  tracesize               :string
#  traynum                 :string
#  xtrapowerprice          :decimal(12, 3)
#  created_at              :datetime         not null
#  updated_at              :datetime         not null
#
# Indexes
#
#  index_orders_on_arcode                             (arcode)
#  index_orders_on_arflag                             (arflag)
#  index_orders_on_backcode                           (backcode)
#  index_orders_on_backflag                           (backflag)
#  index_orders_on_datetimecompleted                  (datetimecompleted)
#  index_orders_on_datetimeframereceived              (datetimeframereceived)
#  index_orders_on_datetimereceived                   (datetimereceived)
#  index_orders_on_hotjobflag                         (hotjobflag)
#  index_orders_on_invoicetotal                       (invoicetotal)
#  index_orders_on_jobtype                            (jobtype)
#  index_orders_on_ltopc                              (ltopc)
#  index_orders_on_mirrcode                           (mirrcode)
#  index_orders_on_mirrflag                           (mirrflag)
#  index_orders_on_orderblanksforf                    (orderblanksforf)
#  index_orders_on_ordercolorcode                     (ordercolorcode)
#  index_orders_on_orderdigitalvendor                 (orderdigitalvendor)
#  index_orders_on_orderlenstype                      (orderlenstype)
#  index_orders_on_orderlnam                          (orderlnam)
#  index_orders_on_ordermaterialcode                  (ordermaterialcode)
#  index_orders_on_ordernum_and_labnum_and_lmssource  (ordernum,labnum,lmssource) UNIQUE
#  index_orders_on_orderpretreatmentcode              (orderpretreatmentcode)
#  index_orders_on_orderstylecode                     (orderstylecode)
#  index_orders_on_polishcode                         (polishcode)
#  index_orders_on_polishflag                         (polishflag)
#  index_orders_on_polzcode                           (polzcode)
#  index_orders_on_polzflag                           (polzflag)
#  index_orders_on_remakecode                         (remakecode)
#  index_orders_on_rtopc                              (rtopc)
#  index_orders_on_subtotal                           (subtotal)
#  index_orders_on_tintcode                           (tintcode)
#  index_orders_on_tintflag                           (tintflag)
#
class Order < ApplicationRecord
  has_many :addon_charges, dependent: :destroy
  has_many :tax_charges, dependent: :destroy
  has_many :order_remarks, dependent: :destroy
  has_many :order_stock_items, dependent: :destroy
  has_many :job_tracker_histories, dependent: :destroy
  has_many :order_frames, dependent: :destroy

  class << self
    def import_from_hash(h)
      h.merge!(h.delete("ordergeneralinfo") || {})
      h.merge!(h.delete("orderpricinginfo") || {})
      h.merge!(h.delete("orderrxinfo") || {})
      h.merge!(h.delete("ordertraceinfo") || {})
      h.merge!(h.delete("ordertreatments") || {})
      h.merge!({"addon_charges" => clean_multi_relation(h.delete("addoncharges"))})
      h.merge!({"tax_charges" => clean_multi_relation(h.delete("taxcharges"))})
      h.merge!({"order_remarks" => clean_multi_relation(h.delete("orderremarks"))})
      h.merge!({"order_stock_items" => clean_multi_relation(h.delete("orderstockitems"))})
      h.merge!({"job_tracker_histories" => clean_multi_relation(h.delete("orderjtinfo"))})
      h.merge!({"order_frames" => extract_frames(h.delete("orderframe"))})
      h['orderponum'] ||= h.delete('ponum')
      super(h)
    end

    def conflict_target
      [:ordernum, :labnum, :lmssource]
    end

    def destroy_old_on_import?(assoc)
      true
    end

    def order_col(right, left)
      if right && (right != '')
        right
      else
        left
      end
    end

    def extract_frames(frame_data = {})
      return [] unless frame_data
      frames = [{
                    'framestatus' => frame_data['framestatus'],
                    'frameid' => frame_data['frameid'],
                    'framecost' => frame_data['framecost'],
                    'framediscountflag' => frame_data['framediscountflag'],
                    'frametaxableflag' => frame_data['frametaxableflag'],
                    'framename' => frame_data['framename'],
                    'framemodel' => frame_data['framemodel'],
                    'framebrand' => frame_data['framebrand'],
                    'framemanuf' => frame_data['framemanuf'],
                    'framecollection' => frame_data['framecollection'],
                    'framecolour' => frame_data['framecolour'],
                    'framesize' => frame_data['framesize'],
                    'ispart' => false,
                    'ismisc' => false,
                }]
      if frame_data['framepartoneid'] && (frame_data['framepartoneid'] != '')
        frames.push({
                        'framestatus' => frame_data['framestatus'],
                        'frameid' => frame_data['framepartoneid'],
                        'framecost' => frame_data['framepartonecost'],
                        'framediscountflag' => frame_data['framepartonediscountflag'],
                        'frametaxableflag' => frame_data['framepartonetaxableflag'],
                        'framename' => frame_data['framepartoneframename'],
                        'framemodel' => frame_data['framepartoneframemodel'],
                        'framebrand' => frame_data['framepartoneframebrand'],
                        'framemanuf' => frame_data['framepartoneframemanuf'],
                        'framecollection' => frame_data['framepartoneframecollection'],
                        'framecolour' => frame_data['framepartoneframecolour'],
                        'framesize' => frame_data['framepartoneframesize'],
                        'ispart' => true,
                        'ismisc' => false,
                    })
      end
      if frame_data['frameparttwoid'] && (frame_data['frameparttwoid'] != '')
        frames.push({
                        'framestatus' => frame_data['framestatus'],
                        'frameid' => frame_data['frameparttwoid'],
                        'framecost' => frame_data['frameparttwocost'],
                        'framediscountflag' => frame_data['frameparttwodiscountflag'],
                        'frametaxableflag' => frame_data['frameparttwotaxableflag'],
                        'framename' => frame_data['frameparttwoframename'],
                        'framemodel' => frame_data['frameparttwoframemodel'],
                        'framebrand' => frame_data['frameparttwoframebrand'],
                        'framemanuf' => frame_data['frameparttwoframemanuf'],
                        'framecollection' => frame_data['frameparttwoframecollection'],
                        'framecolour' => frame_data['frameparttwoframecolour'],
                        'framesize' => frame_data['frameparttwoframesize'],
                        'ispart' => true,
                        'ismisc' => false,
                    })
      end
      if frame_data['misconeid'] && (frame_data['misconeid'] != '')
        frames.push({
                        'framestatus' => frame_data['framestatus'],
                        'frameid' => frame_data['misconeid'],
                        'framecost' => frame_data['misconecost'],
                        'framediscountflag' => frame_data['misconediscountflag'],
                        'frametaxableflag' => frame_data['misconetaxableflag'],
                        'framedesc' => frame_data['misconedesc'],
                        'ispart' => false,
                        'ismisc' => true,
                    })
      end
      if frame_data['misctwoid'] && (frame_data['misctwoid'] != '')
        frames.push({
                        'framestatus' => frame_data['framestatus'],
                        'frameid' => frame_data['misctwoid'],
                        'framecost' => frame_data['misctwocost'],
                        'framediscountflag' => frame_data['misctwodiscountflag'],
                        'frametaxableflag' => frame_data['misctwotaxableflag'],
                        'framedesc' => frame_data['misctwodesc'],
                        'ispart' => false,
                        'ismisc' => true,
                    })
      end
      frames
    end
  end

  compute_on_save(:orderdigitalvendor) do |ord|
    order_col(ord.rtdigitalvendor, ord.ltdigitalvendor)
  end

  compute_on_save(:orderlenstype) do |ord|
    order_col(ord.rtlenstype, ord.ltlenstype)
  end

  compute_on_save(:orderstyle) do |ord|
    order_col(ord.rtstyle, ord.ltstyle)
  end

  compute_on_save(:orderstylecode) do |ord|
    order_col(ord.rtstylecode, ord.ltstylecode)
  end

  compute_on_save(:ordermaterial) do |ord|
    order_col(ord.rtmaterial, ord.ltmaterial)
  end

  compute_on_save(:ordermaterialcode) do |ord|
    order_col(ord.rtmaterialcode, ord.ltmaterialcode)
  end

  compute_on_save(:orderpretreatment) do |ord|
    order_col(ord.rtpretreatment, ord.ltpretreatment)
  end

  compute_on_save(:orderpretreatmentcode) do |ord|
    order_col(ord.rtpretreatmentcode, ord.ltpretreatmentcode)
  end

  compute_on_save(:ordercolor) do |ord|
    order_col(ord.rtcolor, ord.ltcolor)
  end

  compute_on_save(:ordercolorcode) do |ord|
    order_col(ord.rtcolorcode, ord.ltcolorcode)
  end

  compute_on_save(:orderblanksforf) do |ord|
    order_col(ord.rtblanksforf, ord.ltblanksforf)
  end

  compute_on_save(:orderlnam) do |ord|
    order_col(ord.rtlnam, ord.ltlnam)
  end

  compute_on_save(:totaladdonprice) do |ord|
    ord.addon_charges.reduce(0) do |sum, charge|
      sum + (charge.addonprice || 0)
    end
  end

  reportable("order", "Completed Orders", "Report on completed orders", {
=begin
      lmssource: {
          name: "Lab Management System",
          shortname: "LMS",
          groupname: "Internal",
          desc: "The lab management system that produced the order"
      },
=end
  labnum: {
      name: "Lab Number",
      shortname: "Lab",
      groupname: "Internal",
      desc: "The lab that produced the order"
  },
  ordernum: {
      name: "Order Number",
      shortname: "Order",
      groupname: "Internal",
      desc: "The identifying number of the completed order"
  },
  accountnum: {
      name: "Account Number",
      shortname: "Account",
      groupname: "Client",
      desc: "The identifying number of the account that requested the order",
      listable: true
  },
  datetimereceived: {
      name: "Date Received",
      shortname: "Received",
      groupname: "Calendar",
      desc: "The day the order was received from the client"
  },
  datetimecompleted: {
      name: "Date Completed",
      shortname: "Completed",
      groupname: "Calendar",
      desc: "The day the order was completed in-lab"
  },
  datetimeframereceived: {
      name: "Date Frame Received",
      shortname: "Frame Rec",
      groupname: "Calendar",
      desc: "The day the frame was received in-lab"
  },
  datetimewanted: {
      name: "Date Wanted",
      shortname: "Wanted",
      groupname: "Calendar",
      desc: "The day the client wanted to receive the order"
  },
  numdayslate: {
      name: "Days Late",
      shortname: "Late",
      groupname: "Calendar",
      desc: "The number of working days between the wanted date and the completed date"
  },
  timezonediff: {
      name: "Lab Timezone Offset",
      shortname: "Zone",
      groupname: "Calendar",
      desc: "The timezone offset the lab operates in"
  },
  patientname: {
      name: "Patient Name",
      shortname: "Patient",
      groupname: "Client",
      desc: "The patient the order is for"
  },
  traynum: {
      name: "Tray Number",
      shortname: "Tray",
      groupname: "Internal",
      desc: "The number of the tray the order is attached to"
  },
  orderponum: {
      name: "Purchase Order Number",
      shortname: "PO",
      groupname: "Client",
      desc: "The purchase order the order is attached to"
  },
  releasenum: {
      name: "Release Number",
      shortname: "Release",
      groupname: "Client",
      desc: "Group code for releasing shipment"
  },
  hotjobflag: {
      name: "Is Hot Job?",
      shortname: "Hot",
      groupname: "Job Category",
      desc: "Flag indicating if the top is urgent or not"
  },
  jobtype: {
      name: "Job Type",
      groupname: "Job Category",
      desc: "Type of job related to edging and frame status"
  },
  billtonum: {
      name: "Billing Number",
      shortname: "Bill Num",
      groupname: "Client",
      desc: "Client account number to be billed for the job"
  },
  billtoname: {
      name: "Billing Name",
      shortname: "Bill Name",
      groupname: "Client",
      desc: "Client account name to be billed for the job"
  },
  billtogroup: {
      name: "Billing Group",
      shortname: "Bill Group",
      groupname: "Client",
      desc: "Client account group to be billed for the job"
  },
  billtophone: {
      name: "Billing Phone Number",
      shortname: "Bill Phone",
      groupname: "Client",
      desc: "Phone number of client account to be billed for the job"
  },
  billtoaddr1: {
      name: "Billing Address 1",
      shortname: "Bill Addr 1",
      groupname: "Client",
      desc: "Street address of client account to be billed for the job (Line 1)"
  },
  billtoaddr2: {
      name: "Billing Address 2",
      shortname: "Bill Addr 2",
      groupname: "Client",
      desc: "Street address of client account to be billed for the job (Line 2)"
  },
  billtoaddr3: {
      name: "Billing Address 3",
      shortname: "Bill Addr 3",
      groupname: "Client",
      desc: "Street address of client account to be billed for the job (Line 3)"
  },
  billtoaddr4: {
      name: "Billing Address 4",
      shortname: "Bill Addr 4",
      groupname: "Client",
      desc: "Street address of client account to be billed for the job (Line 4)"
  },
  shiptonum: {
      name: "Shipping Number",
      shortname: "Ship Num",
      groupname: "Client",
      desc: "Client account number to ship the job to"
  },
  shiptoname: {
      name: "Shipping Name",
      shortname: "Ship Name",
      groupname: "Client",
      desc: "Client account name to ship the job to"
  },
  shiptogroup: {
      name: "Shipping Group",
      shortname: "Ship Group",
      groupname: "Client",
      desc: "Client account group to ship the job to"
  },
  shiptoaddr1: {
      name: "Shipping Address 1",
      shortname: "Ship Addr 1",
      groupname: "Client",
      desc: "Street address of client account to ship the job to (Line 1)"
  },
  shiptoaddr2: {
      name: "Shipping Address 2",
      shortname: "Ship Addr 2",
      groupname: "Client",
      desc: "Street address of client account to ship the job to (Line 2)"
  },
  shiptoaddr3: {
      name: "Shipping Address 3",
      shortname: "Ship Addr 3",
      groupname: "Client",
      desc: "Street address of client account to ship the job to (Line 3)"
  },
  shiptoaddr4: {
      name: "Shipping Address 4",
      shortname: "Ship Addr 4",
      groupname: "Client",
      desc: "Street address of client account to ship the job to (Line 4)"
  },
  shiptozip: {
      name: "Shipping Zip Code",
      shortname: "Ship Zip",
      groupname: "Client",
      desc: "Zip code of client account to ship the job to"
  },
  shipmethod: {
      name: "Shipping Method",
      shortname: "Ship By",
      groupname: "Client",
      desc: "Shipping method to use for the job"
  },
  shiptracking: {
      name: "Tracking Number",
      shortname: "Track Num",
      groupname: "Client",
      desc: "Tracking number from shipper used to send job"
  },
  envelopenum: {
      name: "Envelope Number",
      shortname: "Env",
      groupname: "Internal",
      desc: "Identifier for job farmed out to 3rd party lab"
  },
  ordersource: {
      name: "Order Source",
      shortname: "Source",
      groupname: "Internal",
      desc: "Where the order originated from"
  },
  salesmancode: {
      name: "Salesman Code",
      shortname: "Sales",
      groupname: "Internal",
      desc: "Identifier of the person who made the sale"
  },
  remakeflag: {
      name: "Is Remake?",
      shortname: "Remake",
      groupname: "Remake",
      desc: "Identifies the job as a remake"
  },
  remakecode: {
      name: "Remake Code",
      groupname: "Remake",
      desc: "General category of the remake"
  },
  remakereason: {
      name: "Remake Reason",
      groupname: "Remake",
      desc: "Specific reason for the remake"
  },
  remakeoriginvnum: {
      name: "Remake Original Invoice Number",
      shortname: "Original Invoice",
      groupname: "Remake",
      desc: "Invoice/order number of original job remade"
  },
  numbreakages: {
      name: "Number of Breakages",
      shortname: "Break Count",
      groupname: "Remake",
      desc: "Number of times order has had a breakage"
  },
  rtdigitalvendor: {
      name: "Right Digital Vendor",
      shortname: "R.Digital Vendor",
      groupname: "Rx Data",
      desc: "Name of the company supplying the free form calculations for the right lens"
  },
  ltdigitalvendor: {
      name: "Left Digital Vendor",
      shortname: "L.Digital Vendor",
      groupname: "Rx Data",
      desc: "Name of the company supplying the free form calculations for the left lens"
  },
  orderdigitalvendor: {
      name: "Order Digital Vendor",
      shortname: "Digital Vendor",
      groupname: "Rx Data",
      desc: "Name of the company supplying the free form calculations for the right lens (if applicable) or the left lens (if right not applicable)"
  },
  rtlenstype: {
      name: "Right Lens Type",
      shortname: "R.Type",
      groupname: "Rx Data",
      desc: "General category of lens type for the right lens (e.g. Single Vision)"
  },
  ltlenstype: {
      name: "Left Lens Type",
      shortname: "L.Type",
      groupname: "Rx Data",
      desc: "General category of lens type for the left lens (e.g. Single Vision)"
  },
  orderlenstype: {
      name: "Order Lens Type",
      shortname: "Type",
      groupname: "Rx Data",
      desc: "General category of lens type for the right lens (if applicable) or the left lens (if right not applicable) (e.g. Single Vision)"
  },
  rtstyle: {
      name: "Right Lens Style",
      shortname: "R.Style",
      groupname: "Blank Data",
      desc: "Design of lens, often manufacturer specific, for the right lens"
  },
  ltstyle: {
      name: "Left Lens Style",
      shortname: "L.Style",
      groupname: "Blank Data",
      desc: "Design of lens, often manufacturer specific, for the left lens"
  },
  orderstyle: {
      name: "Order Lens Style",
      shortname: "Style",
      groupname: "Blank Data",
      desc: "Design of lens, often manufacturer specific, for the right lens (if applicable) or the left lens (if right not applicable)"
  },
  rtstylecode: {
      name: "Right Lens Style Code",
      shortname: "R.Style",
      groupname: "Blank Data",
      desc: "Design of lens, often manufacturer specific, for the right lens"
  },
  ltstylecode: {
      name: "Left Lens Style Code",
      shortname: "L.Style",
      groupname: "Blank Data",
      desc: "Design of lens, often manufacturer specific, for the left lens"
  },
  orderstylecode: {
      name: "Lens Style Code",
      shortname: "Style",
      groupname: "Blank Data",
      desc: "Design of lens, often manufacturer specific, for the right lens (if applicable) or the left lens (if right not applicable)"
  },
  rtmaterial: {
      name: "Right Lens Material",
      shortname: "R.Material",
      groupname: "Blank Data",
      desc: "Description of lens material, usually index specific, but not always, for the right lens"
  },
  ltmaterial: {
      name: "Left Lens Material",
      shortname: "L.Material",
      groupname: "Blank Data",
      desc: "Description of lens material, usually index specific, but not always, for the left lens"
  },
  ordermaterial: {
      name: "Lens Material",
      shortname: "Material",
      groupname: "Blank Data",
      desc: "Description of lens material, usually index specific, but not always, for the right lens (if applicable) or the left lens (if right not applicable)"
  },
  rtmaterialcode: {
      name: "Right Lens Material Code",
      shortname: "R.Material",
      groupname: "Blank Data",
      desc: "Description of lens material, usually index specific, but not always, for the right lens"
  },
  ltmaterialcode: {
      name: "Left Lens Material Code",
      shortname: "L.Material",
      groupname: "Blank Data",
      desc: "Description of lens material, usually index specific, but not always, for the left lens"
  },
  ordermaterialcode: {
      name: "Lens Material Code",
      shortname: "Material",
      groupname: "Blank Data",
      desc: "Description of lens material, usually index specific, but not always, for the right lens (if applicable) or the left lens (if right not applicable)"
  },
  rtpretreatment: {
      name: "Right Lens Pretreatment",
      shortname: "R.Pretreat",
      groupname: "Blank Data",
      desc: "Coating or infusion on/in the right lens blank"
  },
  ltpretreatment: {
      name: "Left Lens Pretreatment",
      shortname: "L.Pretreat",
      groupname: "Blank Data",
      desc: "Coating or infusion on/in the right lens blank"
  },
  orderpretreatment: {
      name: "Order Lens Pretreatment",
      shortname: "Pretreat",
      groupname: "Blank Data",
      desc: "Coating or infusion on/in the right lens blank (if applicable) or the left lens blank (if right not applicable)"
  },
  rtpretreatmentcode: {
      name: "Right Lens Pretreatment Code",
      shortname: "R.Pretreat",
      groupname: "Blank Data",
      desc: "Coating or infusion on/in the right lens blank"
  },
  ltpretreatmentcode: {
      name: "Left Lens Pretreatment Code",
      shortname: "L.Pretreat",
      groupname: "Blank Data",
      desc: "Coating or infusion on/in the right lens blank"
  },
  orderpretreatmentcode: {
      name: "Order Lens Pretreatment Code",
      shortname: "Pretreat",
      groupname: "Blank Data",
      desc: "Coating or infusion on/in the right lens blank (if applicable) or the left lens blank (if right not applicable)"
  },
  rtcolor: {
      name: "Right Lens Color",
      shortname: "R.Color",
      groupname: "Blank Data",
      desc: "Color or tint in the right lens blank"
  },
  ltcolor: {
      name: "Left Lens Color",
      shortname: "L.Color",
      groupname: "Blank Data",
      desc: "Color or tint in the left lens blank"
  },
  ordercolor: {
      name: "Order Lens Color",
      shortname: "Color",
      groupname: "Blank Data",
      desc: "Color or tint in the right lens blank (if applicable) or the left lens blank (if right not applicable)"
  },
  rtcolorcode: {
      name: "Right Lens Color Code",
      shortname: "R.Color",
      groupname: "Blank Data",
      desc: "Color or tint in the right lens blank"
  },
  ltcolorcode: {
      name: "Left Lens Color Code",
      shortname: "L.Color",
      groupname: "Blank Data",
      desc: "Color or tint in the left lens blank"
  },
  ordercolorcode: {
      name: "Order Lens Color Code",
      shortname: "Color",
      groupname: "Blank Data",
      desc: "Color or tint in the right lens blank (if applicable) or the left lens blank (if right not applicable)"
  },
  rtrequestedkind: {
      name: "Right Requested Kind",
      shortname: "R.Req Kind",
      groupname: "Blank Data",
      desc: "Order entry filter to restrict the kind of lenses that are considered in blank selection (right lens)"
  },
  ltrequestedkind: {
      name: "Left Requested Kind",
      shortname: "L.Req Kind",
      groupname: "Blank Data",
      desc: "Order entry filter to restrict the kind of lenses that are considered in blank selection (left lens)"
  },
  rtblanksforf: {
      name: "Right Blank Semi-Finished Or Finished?",
      shortname: "R.Finish Type",
      groupname: "Blank Data",
      desc: "Whether the right lens blank is Finished (F) or Semi-Finished (SF)"
  },
  ltblanksforf: {
      name: "Left Blank Semi-Finished Or Finished?",
      shortname: "L.Finish Type",
      groupname: "Blank Data",
      desc: "Whether the left lens blank is Finished (F) or Semi-Finished (SF)"
  },
  orderblanksforf: {
      name: "Order Blank Semi-Finished Or Finished?",
      shortname: "Finish Type",
      groupname: "Blank Data",
      desc: "Whether the right lens blank is Finished (F) or Semi-Finished (SF) (if applicable) or the left lens blank is Finished (F) or Semi-Finished (SF) (if right not applicable)"
  },
  rtlnam: {
      name: "Right LNAM",
      shortname: "R.LNAM",
      groupname: "Blank Data",
      desc: "LNAM of the right lens"
  },
  ltlnam: {
      name: "Left LNAM",
      shortname: "L.LNAM",
      groupname: "Blank Data",
      desc: "LNAM of the right lens"
  },
  orderlnam: {
      name: "Order LNAM",
      shortname: "LNAM",
      groupname: "Blank Data",
      desc: "LNAM of the right lens (if applicable) or the left lens (if right not applicable)"
  },
  rtsphere: {
      name: "Right Sphere Power",
      shortname: "R.Sphere",
      groupname: "Rx Data",
      desc: "Sphere power of the right lens",
      format: {
          explicit_plus: true,
          zero_pad: 5,
          decimals: 2,
      }
  },
  ltsphere: {
      name: "Left Sphere Power",
      shortname: "L.Sphere",
      groupname: "Rx Data",
      desc: "Sphere power of the left lens",
      format: {
          explicit_plus: true,
          zero_pad: 5,
          decimals: 2,
      }
  },
  rtcylinder: {
      name: "Right Cylinder Power",
      shortname: "R.Cyl",
      groupname: "Rx Data",
      desc: "Cylinder power of the right lens",
      format: {
          explicit_plus: true,
          zero_pad: 5,
          decimals: 2,
      }
  },
  ltcylinder: {
      name: "Left Cylinder Power",
      shortname: "L.Cyl",
      groupname: "Rx Data",
      desc: "Cylinder power of the left lens",
      format: {
          explicit_plus: true,
          zero_pad: 5,
          decimals: 2,
      }
  },
  rtaxis: {
      name: "Right Cylinder Axis",
      shortname: "R.Axis",
      groupname: "Rx Data",
      desc: "Cylinder axis of the right lens"
  },
  ltaxis: {
      name: "Left Cylinder Axis",
      shortname: "L.Axis",
      groupname: "Rx Data",
      desc: "Cylinder axis of the left lens"
  },
  rtadd: {
      name: "Right Add Power",
      shortname: "R.Add",
      groupname: "Rx Data",
      desc: "Add power of the right lens",
      format: {
          explicit_plus: false,
          zero_pad: 4,
          decimals: 2,
      }
  },
  ltadd: {
      name: "Left Add Power",
      shortname: "L.Add",
      groupname: "Rx Data",
      desc: "Add power of the left lens",
      format: {
          explicit_plus: false,
          zero_pad: 4,
          decimals: 2,
      }
  },
  rtupperadd: {
      name: "Right Upper Add Power",
      shortname: "R.Upper Add",
      groupname: "Rx Data",
      desc: "Upper add power of the right lens in an occupational bifocal",
      format: {
          explicit_plus: false,
          zero_pad: 4,
          decimals: 2,
      }
  },
  ltupperadd: {
      name: "Left Upper Add Power",
      shortname: "L.Upper Add",
      groupname: "Rx Data",
      desc: "Upper add power of the left lens in an occupational bifocal",
      format: {
          explicit_plus: false,
          zero_pad: 4,
          decimals: 2,
      }
  },
  rtseght: {
      name: "Right Segment Height",
      shortname: "R.Seg Height",
      groupname: "Rx Data",
      desc: "The height of the segment above the bottom of the virtual frame box in the right lens"
  },
  ltseght: {
      name: "Left Segment Height",
      shortname: "L.Seg Height",
      groupname: "Rx Data",
      desc: "The height of the segment above the bottom of the virtual frame box in the left lens"
  },
  rtocht: {
      name: "Right Optical Center Height",
      shortname: "R.OC Height",
      groupname: "Rx Data",
      desc: "The height of the optical center above the bottom of the virtual frame box, prescribed by the optician or calculated from other fields, such as seg height and BOC, for the right lens"
  },
  ltocht: {
      name: "Left Optical Center Height",
      shortname: "L.OC Height",
      groupname: "Rx Data",
      desc: "The height of the optical center above the bottom of the virtual frame box, prescribed by the optician or calculated from other fields, such as seg height and BOC, for the left lens"
  },
  rtwidth: {
      name: "Right Segment Width",
      shortname: "R.Seg Width",
      groupname: "Rx Data",
      desc: "The width of the segment on the selected lens design (style) for the right lens"
  },
  ltwidth: {
      name: "Left Segment Width",
      shortname: "L.Seg Width",
      groupname: "Rx Data",
      desc: "The width of the segment on the selected lens design (style) for the left lens"
  },
  rtdepth: {
      name: "Right Segment Depth",
      shortname: "R.Seg Depth",
      groupname: "Rx Data",
      desc: "The vertical depth of the trifocal segment on the selected lens design for the right lens"
  },
  ltdepth: {
      name: "Left Segment Depth",
      shortname: "L.Seg Depth",
      groupname: "Rx Data",
      desc: "The vertical depth of the trifocal segment on the selected lens design for the left lens"
  },
  rtpd: {
      name: "Right Pupil Distance",
      shortname: "R.PD",
      groupname: "Rx Data",
      desc: "Pupil Distance (Binocular or Monocular) or Horizontal Decentration for the right eye"
  },
  ltpd: {
      name: "Left Pupil Distance",
      shortname: "L.PD",
      groupname: "Rx Data",
      desc: "Pupil Distance (Binocular or Monocular) or Horizontal Decentration for the left eye"
  },
  rtnearpd: {
      name: "Right Near Pupil Distance",
      shortname: "L.NPD",
      groupname: "Rx Data",
      desc: "Near Pupil Distance (Binocular or Monocular) or Inset from PD for the right eye"
  },
  ltnearpd: {
      name: "Left Near Pupil Distance",
      shortname: "L.NPD",
      groupname: "Rx Data",
      desc: "Near Pupil Distance (Binocular or Monocular) or Inset from PD for the left eye"
  },
  rtverticaldecent: {
      name: "Right Vertical Decentration",
      shortname: "R.VD",
      groupname: "Rx Data",
      desc: "Distance of the optical center above/below the datum line or above the bottom of the B-box for the right eye - valid only for Single Vision"
  },
  ltverticaldecent: {
      name: "Left Vertical Decentration",
      shortname: "L.VD",
      groupname: "Rx Data",
      desc: "Distance of the optical center above/below the datum line or above the bottom of the B-box for the left eye - valid only for Single Vision"
  },
  rtboc: {
      name: "Right BOC",
      shortname: "R.BOC",
      groupname: "Rx Data",
      desc: "Distance from the optical center to the top of the segment for the right lens"
  },
  ltboc: {
      name: "Left BOC",
      shortname: "R.BOC",
      groupname: "Rx Data",
      desc: "Distance from the optical center to the top of the segment for the left lens"
  },
  rtbsd: {
      name: "Right BSD",
      shortname: "R.BSD",
      groupname: "Rx Data",
      desc: "Vertical Distance from the Geometric Center of the blank to the top of the segment for the right lens"
  },
  ltbsd: {
      name: "Left BSD",
      shortname: "L.BSD",
      groupname: "Rx Data",
      desc: "Vertical Distance from the Geometric Center of the blank to the top of the segment for the left lens"
  },
  rtbsi: {
      name: "Right BSI",
      shortname: "R.BSI",
      groupname: "Rx Data",
      desc: "Horizontal Distance from the Geometric Center of the blank to the center of the segment for the right lens"
  },
  ltbsi: {
      name: "Left BSI",
      shortname: "L.BSI",
      groupname: "Rx Data",
      desc: "Horizontal Distance from the Geometric Center of the blank to the center of the segment for the left lens"
  },
  rtthick: {
      name: "Right Thickness",
      shortname: "R.Thick",
      groupname: "Rx Data",
      desc: "Finished thickness requested by order entry for the right lens, if zero, system calculates default thickness based on several parameters. Is assumed to be center thickness on minus, and thinnest edge on plus"
  },
  ltthick: {
      name: "Left Thickness",
      shortname: "L.Thick",
      groupname: "Rx Data",
      desc: "Finished thickness requested by order entry for the left lens, if zero, system calculates default thickness based on several parameters. Is assumed to be center thickness on minus, and thinnest edge on plus"
  },
  rtblankthick: {
      name: "Right Blank Thickness",
      shortname: "R.Blank Thick",
      groupname: "Blank Data",
      desc: "Center thickness of the right lens blank"
  },
  ltblankthick: {
      name: "Left Blank Thickness",
      shortname: "L.Blank Thick",
      groupname: "Blank Data",
      desc: "Center thickness of the left lens blank"
  },
  rtprism: {
      name: "Right Prism",
      shortname: "R.Prism",
      groupname: "Rx Data",
      desc: "Right lens prism"
  },
  ltprism: {
      name: "Left Prism",
      shortname: "L.Prism",
      groupname: "Rx Data",
      desc: "Left lens prism"
  },
  rtprismdirn: {
      name: "Right Prism Direction",
      shortname: "R.Prism Dir",
      groupname: "Rx Data",
      desc: "Right lens prism direction"
  },
  ltprismdirn: {
      name: "Left Prism Direction",
      shortname: "L.Prism Dir",
      groupname: "Rx Data",
      desc: "Left lens prism direction"
  },
  rtprism2: {
      name: "Right Prism 2",
      shortname: "R.Prism 2",
      groupname: "Rx Data",
      desc: "Right lens second prism"
  },
  ltprism2: {
      name: "Left Prism 2",
      shortname: "L.Prism 2",
      groupname: "Rx Data",
      desc: "Left lens second prism"
  },
  rtprismdirn2: {
      name: "Right Prism Direction 2",
      shortname: "R.Prism Dir 2",
      groupname: "Rx Data",
      desc: "Right lens second prism direction"
  },
  ltprismdirn2: {
      name: "Left Prism Direction 2",
      shortname: "L.Prism Dir 2",
      groupname: "Rx Data",
      desc: "Left lens second prism direction"
  },
  rtopc: {
      name: "Right Blank OPC",
      shortname: "R.OPC",
      groupname: "Blank Data",
      desc: "Optical Product Council right lens blank identifier"
  },
  ltopc: {
      name: "Left Blank OPC",
      shortname: "L.OPC",
      groupname: "Blank Data",
      desc: "Optical Product Council left lens blank identifier"
  },
  rtsku: {
      name: "Right Blank SKU",
      shortname: "R.SKU",
      groupname: "Blank Data",
      desc: "Internal stock keeping unit right lens blank identifier"
  },
  ltsku: {
      name: "Left Blank SKU",
      shortname: "L.SKU",
      groupname: "Blank Data",
      desc: "Internal stock keeping unit right lens blank identifier"
  },
  rtblankmanuf: {
      name: "Right Blank Manufacturer",
      shortname: "R.Manufacturer",
      groupname: "Blank Data",
      desc: "Identifier for the manufacturer of the right lens"
  },
  ltblankmanuf: {
      name: "Left Blank Manufacturer",
      shortname: "L.Manufacturer",
      groupname: "Blank Data",
      desc: "Identifier for the manufacturer of the left lens"
  },
  rtblankdiam: {
      name: "Right Blank Diameter",
      shortname: "R.Diameter",
      groupname: "Blank Data",
      desc: "Diameter of the right lens blank"
  },
  ltblankdiam: {
      name: "Left Blank Diameter",
      shortname: "L.Diameter",
      groupname: "Blank Data",
      desc: "Diameter of the left lens blank"
  },
  rtbowlsize: {
      name: "Right Bowl Size",
      shortname: "R.Bowl",
      groupname: "Blank Data",
      desc: "Diameter of the bowl on a lenticular right lens blank"
  },
  ltbowlsize: {
      name: "Left Bowl Size",
      shortname: "L.Bowl",
      groupname: "Blank Data",
      desc: "Diameter of the bowl on a lenticular left lens blank"
  },
  rtcarrier: {
      name: "Right Carrier Curve",
      shortname: "R.Carrier",
      groupname: "Blank Data",
      desc: "Carrier curve in diopters on a lenticular right lens blank"
  },
  ltcarrier: {
      name: "Left Carrier Curve",
      shortname: "L.Carrier",
      groupname: "Blank Data",
      desc: "Carrier curve in diopters on a lenticular right lens blank"
  },
  rtbinlocation: {
      name: "Right Bin Location",
      shortname: "R.Bin",
      groupname: "Blank Data",
      desc: "Physical location identifier for the right lens"
  },
  ltbinlocation: {
      name: "Left Bin Location",
      shortname: "L.Bin",
      groupname: "Blank Data",
      desc: "Physical location identifier for the left lens"
  },
  rtrequestedbase: {
      name: "Right Requested Base",
      shortname: "R.Req Base",
      groupname: "Blank Data",
      desc: "Order entry filter to restrict the base curve of lenses that are considered in right blank selection"
  },
  ltrequestedbase: {
      name: "Left Requested Base",
      shortname: "L.Req Base",
      groupname: "Blank Data",
      desc: "Order entry filter to restrict the base curve of lenses that are considered in left blank selection"
  },
  rtrequesteddiam: {
      name: "Right Requested Diameter",
      shortname: "R.Req Diam",
      groupname: "Blank Data",
      desc: "Order entry filter to restrict the diameter of lenses that are considered in right blank selection"
  },
  ltrequesteddiam: {
      name: "Left Requested Diameter",
      shortname: "L.Req Diam",
      groupname: "Blank Data",
      desc: "Order entry filter to restrict the diameter of lenses that are considered in left blank selection"
  },
  rtrequestedmanuf: {
      name: "Right Requested Manufacturer",
      shortname: "R.Req Man",
      groupname: "Blank Data",
      desc: "Order entry filter to restrict the manufacturer of lenses that are considered in right blank selection"
  },
  ltrequestedmanuf: {
      name: "Left Requested Manufacturer",
      shortname: "L.Req Man",
      groupname: "Blank Data",
      desc: "Order entry filter to restrict the manufacturer of lenses that are considered in left blank selection"
  },
  rtbasetool: {
      name: "Right Base Tool",
      shortname: "R.Base Tool",
      groupname: "Blank Data",
      desc: "The base tool used on the right lens"
  },
  ltbasetool: {
      name: "Left Base Tool",
      shortname: "L.Base Tool",
      groupname: "Blank Data",
      desc: "The base tool used on the left lens"
  },
  rtcrosstool: {
      name: "Right Cross Tool",
      shortname: "R.Cross Tool",
      groupname: "Blank Data",
      desc: "The cross tool used on the right lens"
  },
  ltcrosstool: {
      name: "Left Cross Tool",
      shortname: "L.Cross Tool",
      groupname: "Blank Data",
      desc: "The cross tool used on the left lens"
  },
  rtbasecurve: {
      name: "Right Base Curve",
      shortname: "R.Base Curve",
      groupname: "Blank Data",
      desc: "True front curve of the right lens in diopters"
  },
  ltbasecurve: {
      name: "Left Base Curve",
      shortname: "L.Base Curve",
      groupname: "Blank Data",
      desc: "True front curve of the left lens in diopters"
  },
  tracemodel: {
      name: "Trace Model",
      shortname: "Model",
      groupname: "Trace Data",
      desc: "Job frame trace model identifier"
  },
  tracemanuf: {
      name: "Trace Manufacturer",
      shortname: "Manufacturer",
      groupname: "Trace Data",
      desc: "The frame trace manufacturer code, or \"FTD\" if model is tray number, or \"INV#\" if model is invoice number"
  },
  tracesize: {
      name: "Trace Size",
      shortname: "Size",
      groupname: "Trace Data",
      desc: "The nominal eye and bridge size of the frame trace."
  },
  traceframetype: {
      name: "Trace Type",
      shortname: "Type",
      groupname: "Trace Data",
      desc: "The edge type of the frame trace (metal, rimless, safety etc.)"
  },
  tracea: {
      name: "Trace A",
      shortname: "A",
      groupname: "Trace Data",
      desc: "The \"A\" or horizontal box measurement of the frame"
  },
  traceb: {
      name: "Trace B",
      shortname: "B",
      groupname: "Trace Data",
      desc: "The \"B\" or vertical box measurement of the frame"
  },
  traceed: {
      name: "Trace Effective Diameter",
      shortname: "ED",
      groupname: "Trace Data",
      desc: "The \"ED\" or effective diameter of the frame"
  },
  tracedbl: {
      name: "Trace Distance Between Lenses",
      shortname: "DBL",
      groupname: "Trace Data",
      desc: "The actual distance between the right and left lens at their closest point while mounted in the frame"
  },
  tracecirc: {
      name: "Trace Circumference",
      shortname: "Circ",
      groupname: "Trace Data",
      desc: "The circumference of the frame in mm as measured by a frame tracing device or supplied by the frame manufacturer"
  },
  rtuncutdiam: {
      name: "Right Uncut Diameter",
      shortname: "R.Uncut Diam",
      groupname: "Trace Data",
      desc: "Diameter to crib the right lens for an uncut job"
  },
  ltuncutdiam: {
      name: "Left Uncut Diameter",
      shortname: "L.Uncut Diam",
      groupname: "Trace Data",
      desc: "Diameter to crib the left lens for an uncut job"
  },
  rtuncutellh: {
      name: "Right Uncut ELLH",
      shortname: "R.ELLH",
      groupname: "Trace Data",
      desc: "Vertical diameter of an elliptical uncut shape for the right lens"
  },
  ltuncutellh: {
      name: "Left Uncut ELLH",
      shortname: "L.ELLH",
      groupname: "Trace Data",
      desc: "Vertical diameter of an elliptical uncut shape for the left lens"
  },
  arflag: {
      name: "Has AR?",
      shortname: "AR",
      groupname: "Treatments",
      desc: "Anti-Reflective coating indicator for the job"
  },
  arcode: {
      name: "AR Code",
      shortname: "AR",
      groupname: "Treatments",
      desc: "The specific addon code used"
  },
  ardesc: {
      name: "AR Description",
      shortname: "AR",
      groupname: "Treatments",
      desc: "Description of the AR coating used"
  },
  arcost: {
      name: "AR Cost",
      groupname: "Treatments",
      desc: "Lab's cost of generating the AR coating"
  },
  arprice: {
      name: "AR Price",
      groupname: "Treatments",
      desc: "Lab's charge for adding the AR coating to the lens"
  },
  tintflag: {
      name: "Has Tint?",
      shortname: "Tint",
      groupname: "Treatments",
      desc: "Lens tint coating indicator for the job"
  },
  tintcode: {
      name: "Tint Code",
      shortname: "Tint",
      groupname: "Treatments",
      desc: "The specific tint code used"
  },
  tintdesc: {
      name: "Tint Description",
      shortname: "Tint",
      groupname: "Treatments",
      desc: "Description of the tint coating used"
  },
  tintcost: {
      name: "Tint Cost",
      groupname: "Treatments",
      desc: "Lab's cost of generating the tint coating"
  },
  tintprice: {
      name: "Tint Price",
      groupname: "Treatments",
      desc: "Lab's charge for adding the tint coating to the lens"
  },
  mirrflag: {
      name: "Has Mirror Coat?",
      shortname: "Mirror",
      groupname: "Treatments",
      desc: "Lens mirror coating indicator for the job"
  },
  mirrcode: {
      name: "Mirror Code",
      shortname: "Mirror",
      groupname: "Treatments",
      desc: "The specific mirror code used"
  },
  mirrdesc: {
      name: "Mirror Description",
      shortname: "Mirror",
      groupname: "Treatments",
      desc: "Description of the mirror coating used"
  },
  mirrcost: {
      name: "Mirror Cost",
      groupname: "Treatments",
      desc: "Lab's cost of generating the mirror coating"
  },
  mirrprice: {
      name: "Mirror Price",
      groupname: "Treatments",
      desc: "Lab's charge for adding the mirror coating to the lens"
  },
  backflag: {
      name: "Has Back Coat?",
      shortname: "Back",
      groupname: "Treatments",
      desc: "Backside scratch coating indicator for the job"
  },
  backcode: {
      name: "Back Code",
      shortname: "Back",
      groupname: "Treatments",
      desc: "The specific backside scratch coating code used"
  },
  backdesc: {
      name: "Back Description",
      shortname: "Back",
      groupname: "Treatments",
      desc: "Description of the backside scratch coating used"
  },
  backcost: {
      name: "Back Cost",
      groupname: "Treatments",
      desc: "Lab's cost of generating the backside scratch coating"
  },
  backprice: {
      name: "Back Price",
      groupname: "Treatments",
      desc: "Lab's charge for adding the backside scratch coating to the lens"
  },
  polishflag: {
      name: "Has Edge Polish?",
      shortname: "Polish",
      groupname: "Treatments",
      desc: "Edge polish indicator for the job"
  },
  polishcode: {
      name: "Edge Polish Code",
      shortname: "Polish",
      groupname: "Treatments",
      desc: "The specific edge polish code used"
  },
  polishdesc: {
      name: "Edge Polish Description",
      shortname: "Polish",
      groupname: "Treatments",
      desc: "Description of the edge polish used"
  },
  polishcost: {
      name: "Edge Polish Cost",
      shortname: "Polish Cost",
      groupname: "Treatments",
      desc: "Lab's cost of generating the edge polish"
  },
  polishprice: {
      name: "Edge Polish Price",
      shortname: "Polish Cost",
      groupname: "Treatments",
      desc: "Lab's charge for adding the edge polish to the lens"
  },
  polzflag: {
      name: "Has Polarization?",
      shortname: "Polarization",
      groupname: "Treatments",
      desc: "Polarization indicator for the job"
  },
  polzcode: {
      name: "Polarization Code",
      shortname: "Polarization",
      groupname: "Treatments",
      desc: "The specific polarization code used"
  },
  polzdesc: {
      name: "Polarization Description",
      shortname: "Polarization",
      groupname: "Treatments",
      desc: "Description of the polarization used"
  },
  polzcost: {
      name: "Polarization Cost",
      shortname: "Polz Cost",
      groupname: "Treatments",
      desc: "Lab's cost of generating the polarization"
  },
  polzprice: {
      name: "Polarization Price",
      shortname: "Polz Cost",
      groupname: "Treatments",
      desc: "Lab's charge for adding the polarization to the lens"
  },
  photflag: {
      name: "Has Photochromic?",
      shortname: "Photochromic",
      groupname: "Treatments",
      desc: "Photochromic indicator for the job"
  },
  photcode: {
      name: "Photochromic Code",
      shortname: "Photochromic",
      groupname: "Treatments",
      desc: "The specific photochromic code used"
  },
  photdesc: {
      name: "Photochromic Description",
      shortname: "Photochromic",
      groupname: "Treatments",
      desc: "Description of the photochromic used"
  },
  rtlenscost: {
      name: "Right Lens Cost",
      shortname: "R.Cost",
      groupname: "Blank",
      desc: "Lab inventory cost for the right lens blank"
  },
  ltlenscost: {
      name: "Left Lens Cost",
      shortname: "L.Cost",
      groupname: "Blank",
      desc: "Lab inventory cost for left lens blank"
  },
  rtlensprice: {
      name: "Right Lens Price",
      shortname: "R.Price",
      groupname: "Blank",
      desc: "Lab's base charge for the right lens used"
  },
  ltlensprice: {
      name: "Left Lens Price",
      shortname: "L.Price",
      groupname: "Blank",
      desc: "Lab's base charge for the left lens used"
  },
  xtrapowerprice: {
      name: "Extra Power Price",
      shortname: "Extra Power",
      groupname: "Invoice",
      desc: "Lab's additional charge for Rx over limit"
  },
  totaladdonprice: {
      name: "Total Addon Price",
      shortname: "Addons",
      groupname: "Pricing",
      desc: "The total value of all addons on the order"
  },
  digitalclickfee: {
      name: "Digital Click Fee",
      shortname: "Click Fee",
      groupname: "Pricing",
      desc: "Click fee applied to lens"
  },
  numberdaysframereceived: {
      name: "Frame Received Days",
      shortname: "Frame Days",
      desc: "Number of days between order received and frame received"
  },
  subtotal: {
      name: "Subtotal",
      groupname: "Invoice",
      desc: "Invoice Subtotal"
  },
  invoicetotal: {
      name: "Invoice Total",
      shortname: "Total",
      groupname: "Invoice",
      desc: "Total price of the order to be billed to the client"
  },
  addon_charges: {
      name: "Addons",
      desc: "Addons applied to the order"
  },
  tax_charges: {
      name: "Taxes",
      desc: "Taxes applied to the order"
  },
  order_remarks: {
      name: "Remarks",
      desc: "Remarks applied to the order"
  },
  order_stock_items: {
      name: "Stock Items",
      desc: "Stock items attached to the order"
  },
  job_tracker_histories: {
      name: "Job Tracker History",
      desc: "Job tracker events attached to the order"
  },
  order_frames: {
      name: "Frame",
      desc: "Job tracker events attached to the order"
  },
  })
end
