# == Schema Information
#
# Table name: po_trays
#
#  id                  :bigint           not null, primary key
#  poitemfortraynumber :string
#  created_at          :datetime         not null
#  updated_at          :datetime         not null
#  po_line_id          :bigint
#
# Indexes
#
#  index_po_trays_on_po_line_id  (po_line_id)
#
# Foreign Keys
#
#  fk_rails_...  (po_line_id => po_lines.id) ON DELETE => cascade ON UPDATE => cascade
#
class PoTray < ApplicationRecord
  belongs_to :po_line, optional: true

  class << self
    def import_from_hash(h)
      if h.is_a?(String)
        h = {"poitemfortraynumber" => h}
      end
      super(h)
    end
  end

  reportable("po_tray", "Trays", "Report on purchase order trays", {
      poitemfortraynumber: {
          name: "Item For Tray Number",
          shortname: "Tray Num",
          desc: "Item attached to this tray"
      },
      po_line: {
          name: "PO Line",
          desc: "The PO Line this tray is attached to"
      },
  }, permission_id: 'po_header')
end
