class ArchiveCleanup < RxModule::Routine
  class << self
    def frequency
      "1d"
    end

    def work
      settings = FileMonitorConfig.instance
      if settings.archive_directory && settings.archive_age
        Rails.logger.info { "Checking for archived XML older than #{settings.archive_age} days" }
        FileUtils.mkdir_p(settings.archive_directory)
        target_time = Time.now - (settings.archive_age * 24 * 60 * 60)
        (Dir.entries(settings.archive_directory) - %w[. ..]).each do |entry|
          begin
            file_name = File.join(settings.archive_directory, entry)
            if File.mtime(file_name) <= target_time
              File.delete(file_name)
            end
          rescue StandardError => err
            Utilities::Logger.error { "Issue deleting archived file #{entry}" }
          end
        end
      end
    end
  end
end