class PollMonitor < RxModule::Routine
  class << self
    def frequency
      "5m"
    end

    def work
      location = FileMonitorConfig.instance.incoming_directory
      Rails.logger.info {{action: 'Polling for changes', directory: location}}
      Dir.entries(location)
          .map { |f| File.join(location, f) }
          .reject { |f| File.directory? f }
          .select { |f| FileMonitor.file_pattern.match?(f) }.each do |f|
        ImportXmlJob.perform_later(f, File.size(f))
      end
    end
  end
end