class CreateOrders < ActiveRecord::Migration[6.0]
  def change
    create_table :orders do |t|
      # core info
      t.string :lmssource, null: false
      t.string :labnum, null: false
      t.string :ordernum, null: false

      # general info
      t.string :accountnum
      t.datetime :datetimereceived
      t.datetime :datetimecompleted
      t.datetime :datetimeframereceived
      t.datetime :datetimewanted
      t.integer :numdayslate
      t.float :timezonediff

      t.string :patientname
      t.string :traynum
      t.string :orderponum
      t.string :releasenum
      t.boolean :hotjobflag
      t.string :jobtype

      t.string :billtonum
      t.string :billtoname
      t.string :billtogroup
      t.string :billtophone
      t.string :billtoaddr1
      t.string :billtoaddr2
      t.string :billtoaddr3
      t.string :billtoaddr4

      t.string :shiptonum
      t.string :shiptoname
      t.string :shiptogroup
      t.string :shiptophone
      t.string :shiptoaddr1
      t.string :shiptoaddr2
      t.string :shiptoaddr3
      t.string :shiptoaddr4
      t.string :shiptozip
      t.string :shipmethod
      t.string :shiptracking

      t.string :envelopenum
      t.string :ordersource
      t.string :salesmancode
      t.boolean :remakeflag
      t.string :remakecode
      t.string :remakereason
      t.string :remakeoriginvnum
      t.integer :numbreakages

      # rx info
      t.string :rtdigitalvendor
      t.string :ltdigitalvendor
      t.string :orderdigitalvendor

      t.string :rtlenstype
      t.string :ltlenstype
      t.string :orderlenstype

      t.string :rtstyle
      t.string :ltstyle
      t.string :orderstyle
      t.string :rtstylecode
      t.string :ltstylecode
      t.string :orderstylecode

      t.string :rtmaterial
      t.string :ltmaterial
      t.string :ordermaterial
      t.string :rtmaterialcode
      t.string :ltmaterialcode
      t.string :ordermaterialcode

      t.string :rtpretreatment
      t.string :ltpretreatment
      t.string :orderpretreatment
      t.string :rtpretreatmentcode
      t.string :ltpretreatmentcode
      t.string :orderpretreatmentcode

      t.string :rtcolor
      t.string :ltcolor
      t.string :ordercolor
      t.string :rtcolorcode
      t.string :ltcolorcode
      t.string :ordercolorcode

      t.string :rtrequestedkind
      t.string :ltrequestedkind

      t.string :rtblanksforf
      t.string :ltblanksforf
      t.string :orderblanksforf

      t.string :rtlnam
      t.string :ltlnam
      t.string :orderlnam

      t.float :rtsphere
      t.float :ltsphere

      t.float :rtcylinder
      t.float :ltcylinder

      t.integer :rtaxis
      t.integer :ltaxis

      t.float :rtadd
      t.float :ltadd

      t.float :rtupperadd
      t.float :ltupperadd

      t.float :rtseght
      t.float :ltseght

      t.float :rtocht
      t.float :ltocht

      t.integer :rtwidth
      t.integer :ltwidth

      t.integer :rtdepth
      t.integer :ltdepth

      t.float :rtpd
      t.float :ltpd

      t.float :rtnearpd
      t.float :ltnearpd

      t.float :rtverticaldecent
      t.float :ltverticaldecent

      t.float :rtboc
      t.float :ltboc

      t.float :rtbsd
      t.float :ltbsd

      t.float :rtbsi
      t.float :ltbsi

      t.float :rtthick
      t.float :ltthick
      t.float :rtblankthick
      t.float :ltblankthick

      t.float :rtprism
      t.float :ltprism
      t.float :rtprism2
      t.float :ltprism2
      t.float :rtprismdirn
      t.float :ltprismdirn
      t.float :rtprismdirn2
      t.float :ltprismdirn2

      t.string :rtopc
      t.string :ltopc
      t.string :rtsku
      t.string :ltsku

      t.string :rtblankmanuf
      t.string :ltblankmanuf
      t.integer :rtblankdiam
      t.integer :ltblankdiam
      t.integer :rtbowlsize
      t.integer :ltbowlsize
      t.float :rtcarrier
      t.float :ltcarrier
      t.string :rtbinlocation
      t.string :ltbinlocation

      t.string :rtrequestedbase
      t.string :ltrequestedbase
      t.string :rtrequesteddiam
      t.string :ltrequesteddiam
      t.string :rtrequestedmanuf
      t.string :ltrequestedmanuf

      t.float :rtbasetool
      t.float :ltbasetool
      t.float :rtcrosstool
      t.float :ltcrosstool

      t.float :rtbasecurve
      t.float :ltbasecurve

      # trace info
      t.string :tracemodel
      t.string :tracemanuf
      t.string :tracesize
      t.string :traceframetype
      t.float :tracea
      t.float :traceb
      t.float :traceed
      t.float :tracedbl
      t.float :tracecirc
      t.float :rtuncutdiam
      t.float :ltuncutdiam
      t.float :rtuncutellh
      t.float :ltuncutellh

      # treatments
      t.boolean :arflag
      t.string :arcode
      t.string :ardesc
      t.decimal :arcost, precision: 6, scale: 3
      t.decimal :arprice, precision: 6, scale: 3

      t.boolean :tintflag
      t.string :tintcode
      t.string :tintdesc
      t.decimal :tintcost, precision: 6, scale: 3
      t.decimal :tintprice, precision: 6, scale: 3

      t.boolean :mirrflag
      t.string :mirrcode
      t.string :mirrdesc
      t.decimal :mirrcost, precision: 6, scale: 3
      t.decimal :mirrprice, precision: 6, scale: 3

      t.boolean :backflag
      t.string :backcode
      t.string :backdesc
      t.decimal :backcost, precision: 6, scale: 3
      t.decimal :backprice, precision: 6, scale: 3

      t.boolean :polishflag
      t.string :polishcode
      t.string :polishdesc
      t.decimal :polishcost, precision: 6, scale: 3
      t.decimal :polishprice, precision: 6, scale: 3

      t.boolean :polzflag
      t.string :polzcode
      t.string :polzdesc
      t.decimal :polzcost, precision: 6, scale: 3
      t.decimal :polzprice, precision: 6, scale: 3

      t.boolean :photflag
      t.string :photcode
      t.string :photdesc

      # pricing info
      t.decimal :rtlenscost, precision: 6, scale: 3
      t.decimal :ltlenscost, precision: 6, scale: 3
      t.decimal :rtlensprice, precision: 6, scale: 3
      t.decimal :ltlensprice, precision: 6, scale: 3
      t.decimal :xtrapowerprice, precision: 6, scale: 3
      t.decimal :subtotal, precision: 6, scale: 3
      t.decimal :invoicetotal, precision: 6, scale: 3

      # indexes
      t.index [:ordernum, :labnum, :lmssource], unique: true
      t.index :datetimereceived
      t.index :datetimecompleted
      t.index :datetimeframereceived
      t.index :hotjobflag
      t.index :jobtype
      t.index :remakecode
      t.index :orderdigitalvendor
      t.index :orderlenstype
      t.index :orderstylecode
      t.index :ordermaterialcode
      t.index :orderpretreatmentcode
      t.index :ordercolorcode
      t.index :orderblanksforf
      t.index :orderlnam
      t.index :rtopc
      t.index :ltopc
      t.index :arflag
      t.index :arcode
      t.index :tintflag
      t.index :tintcode
      t.index :mirrflag
      t.index :mirrcode
      t.index :backflag
      t.index :backcode
      t.index :polishflag
      t.index :polishcode
      t.index :polzflag
      t.index :polzcode
      t.index :subtotal
      t.index :invoicetotal

      t.timestamps
    end
  end
end
