class CreateOrderStockItems < ActiveRecord::Migration[6.0]
  def change
    create_table :order_stock_items do |t|
      t.string :stocknum
      t.string :stockdesc
      t.integer :stockqty
      t.integer :stockqtyrt
      t.integer :stockqtylt
      t.decimal :stockcost, precision: 12, scale: 3
      t.decimal :stockprice, precision: 12, scale: 3
      t.boolean :stockdisc
      t.boolean :stocktxble
      t.boolean :stocklr
      t.boolean :stockcomm
      t.string :stockpatient
      t.string :stockitemtype

      t.belongs_to :order, foreign_key: {on_delete: :cascade, on_update: :cascade}

      t.index :stocknum
      t.index :stockqty
      t.index :stockqtyrt
      t.index :stockqtylt

      t.timestamps
    end
  end
end
