class CreateLenses < ActiveRecord::Migration[6.0]
  def change
    create_table :lenses do |t|
      t.string :lmssource, null: false
      t.string :lensdescription, null: false

      # lens characteristics
      t.string :lensmanufacturercode
      t.string :lensmanufacturerdesc
      t.string :lensstylecode
      t.string :lensstyledesc
      t.string :lensstyletype
      t.string :lensmaterialcode
      t.string :lensmaterialdesc
      t.string :lenstintcode
      t.string :lenstintdesc
      t.string :lenstreatcode
      t.string :lenstreatdesc
      t.string :lensclass
      t.float :lenssegwidth
      t.float :lenssegdepth
      t.string :lenssphere
      t.string :lenscylinder
      t.string :lensbase
      t.string :lensadd
      t.string :lensupperadd
      t.float :lensdiameter
      t.string :lensthicknesscode
      t.string :lensopc
      t.string :lensopcright
      t.string :lensopcleft

      # lens technicals
      t.boolean :lensnetitem
      t.boolean :lensrightleftitem
      t.float :lensfrontcurve
      t.float :lensfrontcurveradius
      t.float :lensbackcurve
      t.float :lensbackcurveradius
      t.float :lenscenterthickness
      t.float :lensbowldiameter
      t.float :lenscarriercurve
      t.float :lenscarriercurveradius
      t.float :lenssegmentthickness
      t.float :lenssagreading
      t.float :lenspolarizedcurve
      t.float :lenspolarizedcurveradius
      t.float :lenspolarizedmmfromfront
      t.float :lensblkd
      t.float :lensrngh
      t.float :lenslblhi
      t.float :lensblkdm
      t.float :lensblkcehi
      t.float :lensblkrd
      t.float :lenskprvm
      t.float :lenskprva

      # indexes
      t.index [:lensdescription, :lmssource], unique: true
      t.index :lensmanufacturercode
      t.index :lensstylecode
      t.index :lensmaterialcode
      t.index :lenstreatcode
      t.index :lensopc
      t.index :lensopcright
      t.index :lensopcleft

      t.timestamps
    end
  end
end
