class CreateLensWarehouseData < ActiveRecord::Migration[6.0]
  def change
    create_table :lens_warehouse_data do |t|
      t.string :lenswarehouseid, null: true
      t.string :lensstocknum, null: true
      t.string :lensbin
      t.boolean :lensstockitem
      t.integer :lenspriority
      t.integer :lensdatewanteddays
      t.string :lensreordermethod
      t.integer :lenssafetydays
      t.integer :lensshipdays
      t.integer :lensmaxsupplydays
      t.integer :lenshistorymonths
      t.float :lensreorderfactor
      t.integer :lensreorderlevel
      t.integer :lensmaximumqty
      t.integer :lensqtyinstock
      t.integer :lensqtyinstockright
      t.integer :lensqtyinstockleft
      t.float :lensqtyeoq
      t.string :lensvendor
      t.decimal :lensvendorcost, precision: 12, scale: 3
      t.decimal :lensaveragecost, precision: 12, scale: 3
      t.float :lensaveragemonthlyusage
      t.float :lensaveragedailyusage
      t.integer :lensqtyonorder
      t.integer :lensqtyonorderright
      t.integer :lensqtyonorderleft
      t.integer :lensqtyallocated
      t.integer :lensqtyallocatedright
      t.integer :lensqtyallocatedleft
      t.integer :lensqtyinproc
      t.integer :lensqtyinprocright
      t.integer :lensqtyinprocleft
      t.integer :lensqtyusedsincelastorder
      t.integer :lensqtyusedsincelastorderright
      t.integer :lensqtyusedsincelastorderleft
      t.decimal :lenstotalaveragecost, precision: 12, scale: 3
      t.decimal :lenstotalstandardcost, precision: 12, scale: 3
      t.integer :lensqtyonshelf
      t.integer :lensqtyonshelfright
      t.integer :lensqtyonshelfleft
      t.boolean :lensoverstockflag
      t.integer :lensoverstockqty
      t.decimal :lensoverstockamount, precision: 12, scale: 3

      t.references :lens, foreign_key: {on_delete: :cascade, on_update: :cascade}

      # indexes
      t.index [:lensstocknum, :lenswarehouseid], unique: true
      t.index :lenswarehouseid
      t.index :lensaveragemonthlyusage

      t.timestamps
    end
  end
end
