class CreatePoHeaders < ActiveRecord::Migration[6.0]
  def change
    create_table :po_headers do |t|
      t.string :lmssource, null: false
      t.string :labnum, null: false
      t.string :ponum, null: false
      t.string :postatus
      t.string :povendorid
      t.string :povendorname
      t.datetime :podate
      t.decimal :pototal, precision: 12, scale: 2
      t.string :poreordermethod
      t.string :potype
      t.string :poopcfilename
      t.string :poopcconfirmation
      t.boolean :potransmitted
      t.datetime :poclosedate
      t.datetime :poreceivedate
      t.integer :poqty
      t.decimal :poamount, precision: 12, scale: 2

      # indexes
      t.index [:ponum, :labnum, :lmssource], unique: true
      t.index :labnum
      t.index :postatus
      t.index :povendorid
      t.index :podate
      t.index :potype
      t.index :poclosedate
      t.index :poreceivedate

      t.timestamps
    end
  end
end
