class CreatePoLines < ActiveRecord::Migration[6.0]
  def change
    create_table :po_lines do |t|
      t.string :lensstocknum
      t.integer :lensqtyonorder
      t.integer :lensqtyonorderright
      t.integer :lensqtyonorderleft
      t.integer :lensqtyreceived
      t.integer :lensqtyreceivedright
      t.integer :lensqtyreceivedleft
      t.integer :lensqtysuggested
      t.integer :lensqtysuggestedright
      t.integer :lensqtysuggestedleft
      t.decimal :lensunitprice, precision: 12, scale: 3
      t.string :lensvendernumber

      t.belongs_to :po_header, foreign_key: {on_delete: :cascade, on_update: :cascade}
      t.belongs_to :lens, foreign_key: {on_delete: :nullify, on_update: :cascade}

      # indexes
      t.index :lensstocknum
      t.index :lensvendernumber

      t.timestamps
    end
  end
end
