class CreateStoreJobData < ActiveRecord::Migration[6.0]
  def change
    create_table :store_job_data do |t|
      t.string :lmssource, null: false
      t.string :lenswarehouseid, null: true
      t.date :lenswarehousedate, null: false
      t.integer :storedematrixlenses
      t.integer :storedematrixbreak
      t.integer :storedenonmatrixlenses
      t.integer :storedenonmatrixbreak
      t.integer :storedetotallenses
      t.integer :storedetotalbreak
      t.integer :storedesemifinlenses
      t.integer :storedesemifinbreak
      t.integer :storedefinlenses
      t.integer :storedefinbreak
      t.integer :storedecorpuncut
      t.integer :storedecorpuncutbreak
      t.integer :storedecorpedged
      t.integer :storedecorpedgedbreak
      t.integer :storejobscompletewithinv
      t.integer :storejobscompletenoinv
      t.integer :storejobsoutstandwithinv
      t.integer :storejobsoutstandnoinv
      t.integer :storetotaljobscompleted
      t.integer :storetotaljobsoutstanding

      t.index [:lenswarehouseid, :lenswarehousedate, :lmssource], unique: true, name: 'store_jobs_unique_key'
      t.index :lenswarehousedate

      t.timestamps
    end
  end
end
