class CreateLensTransactions < ActiveRecord::Migration[6.0]
  def change
    create_table :lens_transactions do |t|
      t.string :lmssource, null: false
      t.string :stxopc
      t.datetime :stxdatetime, null: false
      t.string :stxtransactiontype
      t.string :stxtransactiontypedesc
      t.string :stxtransactioncode
      t.string :stxtransactioncodedesc
      t.string :stxdescription
      t.integer :stxqty
      t.integer :stxqtyright
      t.integer :stxqtyleft
      t.decimal :stxunitcost, precision: 12, scale: 3
      t.integer :stxcount
      t.integer :stxcountright
      t.integer :stxcountleft
      t.string :stxemployeecode
      t.string :stxordernum
      t.string :stxlensstocknum
      t.string :stxlenswarehouseid, null: true
      t.decimal :stxtotalcost, precision: 12, scale: 3
      t.integer :stxcomputedinstock
      t.integer :stxcomputedinstockright
      t.integer :stxcomputedinstockleft

      t.belongs_to :lens, foreign_key: {on_delete: :cascade, on_update: :cascade}

      t.index [:stxdatetime, :stxlenswarehouseid, :lmssource], unique: true, name: 'lens_transaction_unique_key'
      t.index :stxopc
      t.index :stxtransactiontype
      t.index :stxtransactioncode
      t.index :stxdescription
      t.index :stxlensstocknum
      t.index :stxlenswarehouseid

      t.timestamps
    end
  end
end
