class CreateCorporateConsolidatedStockTransactions < ActiveRecord::Migration[6.0]
  def change
    create_table :corporate_consolidated_stock_transactions do |t|
      t.string :lmssource, null: false
      t.string :ccstxlenswarehouseid, null: true
      t.date :ccstxdate, null: false
      t.integer :ccstxtotalqty
      t.decimal :ccstxtotalcost, precision: 12, scale: 2
      t.integer :ccstxtotalreceiveqty
      t.decimal :ccstxtotalreceivecost, precision: 12, scale: 2
      t.integer :ccstxtotalusageqty
      t.decimal :ccstxtotalusagecost, precision: 12, scale: 2
      t.integer :ccstxtotalwastageqty
      t.decimal :ccstxtotalwastagecost, precision: 12, scale: 2
      t.integer :ccstxtotalreturnqty
      t.decimal :ccstxtotalreturncost, precision: 12, scale: 2
      t.integer :ccstxtotaladjustqty
      t.decimal :ccstxtotaladjustcost, precision: 12, scale: 2
      t.integer :ccstxtotalcountvariance
      t.decimal :ccstxtotalcountvariancecost, precision: 12, scale: 2
      t.integer :ccstxtotalpoqty
      t.decimal :ccstxtotalpocost, precision: 12, scale: 2
      t.decimal :ccstxperpetualbalance, precision: 12, scale: 2
      t.integer :ccstxtotalcyclecountqty
      t.decimal :ccstxtotalcyclecountcost, precision: 12, scale: 2
      t.decimal :ccstxopenpurchases, precision: 12, scale: 2
      t.decimal :ccstxperpetualbalanceadjust, precision: 12, scale: 2
      t.decimal :ccstxtotallensadjustments, precision: 12, scale: 2
      t.decimal :ccstxendingperpetualbalance, precision: 12, scale: 2
      t.decimal :ccstxcalcendingperpetualbalance, precision: 12, scale: 2

      t.index [:ccstxlenswarehouseid, :ccstxdate, :lmssource], unique: true, name: 'ccstx_unique_id'
      t.index :ccstxdate

      t.timestamps
    end
  end
end
