class AddLinkBetweenTransactionsAndWarehouse < ActiveRecord::Migration[6.0]
  class LensTransaction < ActiveRecord::Base; end
  class LensWarehouseDatum < ActiveRecord::Base; end

  def up
    add_column :lens_transactions, :warehouse_link, :string
    add_index :lens_transactions, :warehouse_link
    add_column :lens_warehouse_data, :stx_link, :string
    add_index :lens_warehouse_data, :stx_link

    LensTransaction.update_all("warehouse_link=CONCAT(stxlenswarehouseid, lens_id)")
    LensWarehouseDatum.update_all("stx_link=CONCAT(lenswarehouseid, lens_id)")
  end

  def down
    remove_index :lens_transactions, :warehouse_link
    remove_column :lens_transactions, :warehouse_link
    remove_index :lens_warehouse_data, :stx_link
    remove_column :lens_warehouse_data, :stx_link
  end
end
