class AddVendorValuesToWarehouse < ActiveRecord::Migration[6.0]
  class LensWarehouseDatum < ActiveRecord::Base;
  end

  def up
    add_column :lens_warehouse_data, :lensvalinstock, :decimal, precision: 12, scale: 3
    add_column :lens_warehouse_data, :lensvalonorder, :decimal, precision: 12, scale: 3
    add_column :lens_warehouse_data, :lensvalallocated, :decimal, precision: 12, scale: 3
    add_column :lens_warehouse_data, :lensvalinproc, :decimal, precision: 12, scale: 3
    add_column :lens_warehouse_data, :lensvalusedsincelastorder, :decimal, precision: 12, scale: 3
    add_column :lens_warehouse_data, :lensvalonshelf, :decimal, precision: 12, scale: 3

    LensWarehouseDatum.update_all("lensvalinstock=(COALESCE(lensqtyinstock, 0) + COALESCE(lensqtyinstockright, 0) + COALESCE(lensqtyinstockleft, 0)) * COALESCE(lensvendorcost, 0)")
    LensWarehouseDatum.update_all("lensvalonorder=(COALESCE(lensqtyonorder, 0) + COALESCE(lensqtyonorderright, 0) + COALESCE(lensqtyonorderleft, 0)) * COALESCE(lensvendorcost, 0)")
    LensWarehouseDatum.update_all("lensvalallocated=(COALESCE(lensqtyallocated, 0) + COALESCE(lensqtyallocatedright, 0) + COALESCE(lensqtyallocatedleft, 0)) * COALESCE(lensvendorcost, 0)")
    LensWarehouseDatum.update_all("lensvalinproc=(COALESCE(lensqtyinproc, 0) + COALESCE(lensqtyinprocright, 0) + COALESCE(lensqtyinprocleft, 0)) * COALESCE(lensvendorcost, 0)")
    LensWarehouseDatum.update_all("lensvalusedsincelastorder=(COALESCE(lensqtyusedsincelastorder, 0) + COALESCE(lensqtyusedsincelastorderright, 0) + COALESCE(lensqtyusedsincelastorderleft, 0)) * COALESCE(lensvendorcost, 0)")
    LensWarehouseDatum.update_all("lensvalonshelf=(COALESCE(lensqtyonshelf, 0) + COALESCE(lensqtyonshelfright, 0) + COALESCE(lensqtyonshelfleft, 0)) * COALESCE(lensvendorcost, 0)")
  end

  def down
    remove_column :lens_transactions, :lensvalinstock
    remove_column :lens_transactions, :lensvalonorder
    remove_column :lens_transactions, :lensvalallocated
    remove_column :lens_transactions, :lensvalinproc
    remove_column :lens_transactions, :lensvalusedsincelastorder
    remove_column :lens_transactions, :lensvalonshelf
  end
end
