class CreateOrderFrames < ActiveRecord::Migration[6.0]
  def change
    create_table :order_frames do |t|
      t.string :framestatus
      t.string :frameid
      t.decimal :framecost, precision: 12, scale: 3
      t.boolean :framediscountflag
      t.boolean :frametaxableflag
      t.string :framedesc
      t.boolean :ispart
      t.boolean :ismisc

      t.belongs_to :order, foreign_key: {on_delete: :cascade, on_update: :cascade}

      # indexes
      t.index :frameid
      t.index :framecost
      t.index :framestatus

      t.timestamps
    end
  end
end
