# This file is auto-generated from the current state of the database. Instead
# of editing this file, please use the migrations feature of Active Record to
# incrementally modify your database, and then regenerate this schema definition.
#
# This file is the source Rails uses to define your schema when running `rails
# db:schema:load`. When creating a new database, `rails db:schema:load` tends to
# be faster and is potentially less error prone than running all of your
# migrations from scratch. Old migrations may fail to apply correctly if those
# migrations use external dependencies or application code.
#
# It's strongly recommended that you check this file into your version control system.

ActiveRecord::Schema.define(version: 2020_11_17_181840) do

  # These are extensions that must be enabled in order to support this database
  enable_extension "plpgsql"

  create_table "addon_charges", force: :cascade do |t|
    t.string "addondesc"
    t.decimal "addonprice", precision: 12, scale: 3
    t.string "addoncode"
    t.bigint "order_id"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.index ["addoncode"], name: "index_addon_charges_on_addoncode"
    t.index ["order_id"], name: "index_addon_charges_on_order_id"
  end

  create_table "corporate_consolidated_stock_transactions", force: :cascade do |t|
    t.string "lmssource", null: false
    t.string "ccstxlenswarehouseid"
    t.date "ccstxdate", null: false
    t.integer "ccstxtotalqty"
    t.integer "ccstxtotalreceiveqty"
    t.decimal "ccstxtotalreceivecost", precision: 12, scale: 2
    t.integer "ccstxtotalusageqty"
    t.decimal "ccstxtotalusagecost", precision: 12, scale: 2
    t.integer "ccstxtotalwastageqty"
    t.decimal "ccstxtotalwastagecost", precision: 12, scale: 2
    t.integer "ccstxtotalreturnqty"
    t.decimal "ccstxtotalreturncost", precision: 12, scale: 2
    t.integer "ccstxtotaladjustqty"
    t.decimal "ccstxtotaladjustcost", precision: 12, scale: 2
    t.integer "ccstxtotalcountvariance"
    t.decimal "ccstxtotalcountvariancecost", precision: 12, scale: 2
    t.integer "ccstxtotalpoqty"
    t.decimal "ccstxtotalpocost", precision: 12, scale: 2
    t.decimal "ccstxperpetualbalance", precision: 12, scale: 2
    t.integer "ccstxtotalcyclecountqty"
    t.decimal "ccstxtotalcyclecountcost", precision: 12, scale: 2
    t.decimal "ccstxopenpurchases", precision: 12, scale: 2
    t.decimal "ccstxperpetualbalanceadjust", precision: 12, scale: 2
    t.decimal "ccstxtotallensadjustments", precision: 12, scale: 2
    t.decimal "ccstxendingperpetualbalance", precision: 12, scale: 2
    t.decimal "ccstxcalcendingperpetualbalance", precision: 12, scale: 2
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.decimal "ccstxbeginningperpetualbalance", precision: 12, scale: 2
    t.boolean "is_placeholder"
    t.index ["ccstxdate"], name: "index_corporate_consolidated_stock_transactions_on_ccstxdate"
    t.index ["ccstxlenswarehouseid", "ccstxdate", "lmssource"], name: "ccstx_unique_id", unique: true
  end

  create_table "file_monitor_configs", force: :cascade do |t|
    t.string "incoming_directory"
    t.string "archive_directory"
    t.string "error_directory"
    t.integer "archive_age"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
  end

  create_table "job_tracker_histories", force: :cascade do |t|
    t.datetime "jtdatetime"
    t.string "jtstation"
    t.string "jtdesc"
    t.string "jtmessage"
    t.string "jtoperator"
    t.bigint "order_id"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.index ["jtdatetime"], name: "index_job_tracker_histories_on_jtdatetime"
    t.index ["jtstation"], name: "index_job_tracker_histories_on_jtstation"
    t.index ["order_id"], name: "index_job_tracker_histories_on_order_id"
  end

  create_table "lens_transactions", force: :cascade do |t|
    t.string "lmssource", null: false
    t.string "stxopc"
    t.datetime "stxdatetime", null: false
    t.string "stxtransactiontype"
    t.string "stxtransactiontypedesc"
    t.string "stxtransactioncode"
    t.string "stxtransactioncodedesc"
    t.string "stxdescription"
    t.integer "stxqty"
    t.integer "stxqtyright"
    t.integer "stxqtyleft"
    t.decimal "stxunitcost", precision: 12, scale: 3
    t.integer "stxcount"
    t.integer "stxcountright"
    t.integer "stxcountleft"
    t.string "stxemployeecode"
    t.string "stxordernum"
    t.string "stxlensstocknum"
    t.string "stxlenswarehouseid"
    t.decimal "stxtotalcost", precision: 12, scale: 3
    t.integer "stxcomputedinstock"
    t.integer "stxcomputedinstockright"
    t.integer "stxcomputedinstockleft"
    t.bigint "lens_id"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.decimal "stxvendorcost", precision: 12, scale: 3
    t.string "warehouse_link"
    t.decimal "stxtotalvendorcost", precision: 12, scale: 3
    t.index ["lens_id"], name: "index_lens_transactions_on_lens_id"
    t.index ["stxdatetime", "stxlenswarehouseid", "lmssource"], name: "lens_transaction_unique_key", unique: true
    t.index ["stxdescription"], name: "index_lens_transactions_on_stxdescription"
    t.index ["stxlensstocknum"], name: "index_lens_transactions_on_stxlensstocknum"
    t.index ["stxlenswarehouseid"], name: "index_lens_transactions_on_stxlenswarehouseid"
    t.index ["stxopc"], name: "index_lens_transactions_on_stxopc"
    t.index ["stxordernum"], name: "index_lens_transactions_on_stxordernum"
    t.index ["stxtransactioncode"], name: "index_lens_transactions_on_stxtransactioncode"
    t.index ["stxtransactiontype"], name: "index_lens_transactions_on_stxtransactiontype"
    t.index ["warehouse_link"], name: "index_lens_transactions_on_warehouse_link"
  end

  create_table "lens_warehouse_data", force: :cascade do |t|
    t.string "lenswarehouseid"
    t.string "lensstocknum"
    t.string "lensbin"
    t.boolean "lensstockitem"
    t.integer "lenspriority"
    t.integer "lensdatewanteddays"
    t.string "lensreordermethod"
    t.integer "lenssafetydays"
    t.integer "lensshipdays"
    t.integer "lensmaxsupplydays"
    t.integer "lenshistorymonths"
    t.float "lensreorderfactor"
    t.integer "lensreorderlevel"
    t.integer "lensmaximumqty"
    t.integer "lensqtyinstock"
    t.integer "lensqtyinstockright"
    t.integer "lensqtyinstockleft"
    t.float "lensqtyeoq"
    t.string "lensvendor"
    t.decimal "lensvendorcost", precision: 12, scale: 3
    t.decimal "lensaveragecost", precision: 12, scale: 3
    t.float "lensaveragemonthlyusage"
    t.float "lensaveragedailyusage"
    t.integer "lensqtyonorder"
    t.integer "lensqtyonorderright"
    t.integer "lensqtyonorderleft"
    t.integer "lensqtyallocated"
    t.integer "lensqtyallocatedright"
    t.integer "lensqtyallocatedleft"
    t.integer "lensqtyinproc"
    t.integer "lensqtyinprocright"
    t.integer "lensqtyinprocleft"
    t.integer "lensqtyusedsincelastorder"
    t.integer "lensqtyusedsincelastorderright"
    t.integer "lensqtyusedsincelastorderleft"
    t.decimal "lenstotalaveragecost", precision: 12, scale: 3
    t.decimal "lenstotalstandardcost", precision: 12, scale: 3
    t.integer "lensqtyonshelf"
    t.integer "lensqtyonshelfright"
    t.integer "lensqtyonshelfleft"
    t.boolean "lensoverstockflag"
    t.integer "lensoverstockqty"
    t.decimal "lensoverstockamount", precision: 12, scale: 3
    t.bigint "lens_id"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.string "stx_link"
    t.decimal "lensvalinstock", precision: 12, scale: 3
    t.decimal "lensvalonorder", precision: 12, scale: 3
    t.decimal "lensvalallocated", precision: 12, scale: 3
    t.decimal "lensvalinproc", precision: 12, scale: 3
    t.decimal "lensvalusedsincelastorder", precision: 12, scale: 3
    t.decimal "lensvalonshelf", precision: 12, scale: 3
    t.index ["lens_id"], name: "index_lens_warehouse_data_on_lens_id"
    t.index ["lensaveragemonthlyusage"], name: "index_lens_warehouse_data_on_lensaveragemonthlyusage"
    t.index ["lensstocknum", "lenswarehouseid"], name: "index_lens_warehouse_data_on_lensstocknum_and_lenswarehouseid"
    t.index ["lenswarehouseid"], name: "index_lens_warehouse_data_on_lenswarehouseid"
    t.index ["stx_link"], name: "index_lens_warehouse_data_on_stx_link"
  end

  create_table "lenses", force: :cascade do |t|
    t.string "lmssource", null: false
    t.string "lensdescription", null: false
    t.string "lensmanufacturercode"
    t.string "lensmanufacturerdesc"
    t.string "lensstylecode"
    t.string "lensstyledesc"
    t.string "lensstyletype"
    t.string "lensmaterialcode"
    t.string "lensmaterialdesc"
    t.string "lenstintcode"
    t.string "lenstintdesc"
    t.string "lenstreatcode"
    t.string "lenstreatdesc"
    t.string "lensclass"
    t.float "lenssegwidth"
    t.float "lenssegdepth"
    t.decimal "lenssphere", precision: 7, scale: 3
    t.decimal "lenscylinder", precision: 7, scale: 3
    t.decimal "lensbase", precision: 7, scale: 3
    t.decimal "lensadd", precision: 7, scale: 3
    t.decimal "lensupperadd", precision: 7, scale: 3
    t.float "lensdiameter"
    t.string "lensthicknesscode"
    t.string "lensopc"
    t.string "lensopcright"
    t.string "lensopcleft"
    t.boolean "lensnetitem"
    t.boolean "lensrightleftitem"
    t.float "lensfrontcurve"
    t.float "lensfrontcurveradius"
    t.float "lensbackcurve"
    t.float "lensbackcurveradius"
    t.float "lenscenterthickness"
    t.float "lensbowldiameter"
    t.float "lenscarriercurve"
    t.float "lenscarriercurveradius"
    t.float "lenssegmentthickness"
    t.float "lenssagreading"
    t.float "lenspolarizedcurve"
    t.float "lenspolarizedcurveradius"
    t.float "lenspolarizedmmfromfront"
    t.float "lensblkd"
    t.float "lensrngh"
    t.float "lenslblhi"
    t.float "lensblkdm"
    t.float "lensblkcehi"
    t.float "lensblkrd"
    t.float "lenskprvm"
    t.float "lenskprva"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.index ["lensdescription", "lmssource"], name: "index_lenses_on_lensdescription_and_lmssource", unique: true
    t.index ["lensmanufacturercode"], name: "index_lenses_on_lensmanufacturercode"
    t.index ["lensmaterialcode"], name: "index_lenses_on_lensmaterialcode"
    t.index ["lensopc"], name: "index_lenses_on_lensopc"
    t.index ["lensopcleft"], name: "index_lenses_on_lensopcleft"
    t.index ["lensopcright"], name: "index_lenses_on_lensopcright"
    t.index ["lensstylecode"], name: "index_lenses_on_lensstylecode"
    t.index ["lenstreatcode"], name: "index_lenses_on_lenstreatcode"
  end

  create_table "order_frames", force: :cascade do |t|
    t.string "framestatus"
    t.string "frameid"
    t.decimal "framecost", precision: 12, scale: 3
    t.boolean "framediscountflag"
    t.boolean "frametaxableflag"
    t.string "framedesc"
    t.boolean "ispart"
    t.boolean "ismisc"
    t.bigint "order_id"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.string "framename"
    t.string "framemodel"
    t.string "framebrand"
    t.string "framemanuf"
    t.string "framecollection"
    t.string "framecolour"
    t.string "framesize"
    t.index ["framecost"], name: "index_order_frames_on_framecost"
    t.index ["frameid"], name: "index_order_frames_on_frameid"
    t.index ["framestatus"], name: "index_order_frames_on_framestatus"
    t.index ["order_id"], name: "index_order_frames_on_order_id"
  end

  create_table "order_remarks", force: :cascade do |t|
    t.string "remark"
    t.bigint "order_id"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.index ["order_id"], name: "index_order_remarks_on_order_id"
  end

  create_table "order_stock_items", force: :cascade do |t|
    t.string "stocknum"
    t.string "stockdesc"
    t.integer "stockqty"
    t.integer "stockqtyrt"
    t.integer "stockqtylt"
    t.decimal "stockcost", precision: 12, scale: 3
    t.decimal "stockprice", precision: 12, scale: 3
    t.boolean "stockdisc"
    t.boolean "stocktxble"
    t.boolean "stocklr"
    t.boolean "stockcomm"
    t.string "stockpatient"
    t.string "stockitemtype"
    t.bigint "order_id"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.index ["order_id"], name: "index_order_stock_items_on_order_id"
    t.index ["stocknum"], name: "index_order_stock_items_on_stocknum"
    t.index ["stockqty"], name: "index_order_stock_items_on_stockqty"
    t.index ["stockqtylt"], name: "index_order_stock_items_on_stockqtylt"
    t.index ["stockqtyrt"], name: "index_order_stock_items_on_stockqtyrt"
  end

  create_table "orders", force: :cascade do |t|
    t.string "lmssource", null: false
    t.string "labnum", null: false
    t.string "ordernum", null: false
    t.string "accountnum"
    t.datetime "datetimereceived"
    t.datetime "datetimecompleted"
    t.datetime "datetimeframereceived"
    t.datetime "datetimewanted"
    t.integer "numdayslate"
    t.float "timezonediff"
    t.string "patientname"
    t.string "traynum"
    t.string "orderponum"
    t.string "releasenum"
    t.boolean "hotjobflag"
    t.string "jobtype"
    t.string "billtonum"
    t.string "billtoname"
    t.string "billtogroup"
    t.string "billtophone"
    t.string "billtoaddr1"
    t.string "billtoaddr2"
    t.string "billtoaddr3"
    t.string "billtoaddr4"
    t.string "shiptonum"
    t.string "shiptoname"
    t.string "shiptogroup"
    t.string "shiptophone"
    t.string "shiptoaddr1"
    t.string "shiptoaddr2"
    t.string "shiptoaddr3"
    t.string "shiptoaddr4"
    t.string "shiptozip"
    t.string "shipmethod"
    t.string "shiptracking"
    t.string "envelopenum"
    t.string "ordersource"
    t.string "salesmancode"
    t.boolean "remakeflag"
    t.string "remakecode"
    t.string "remakereason"
    t.string "remakeoriginvnum"
    t.integer "numbreakages"
    t.string "rtdigitalvendor"
    t.string "ltdigitalvendor"
    t.string "orderdigitalvendor"
    t.string "rtlenstype"
    t.string "ltlenstype"
    t.string "orderlenstype"
    t.string "rtstyle"
    t.string "ltstyle"
    t.string "orderstyle"
    t.string "rtstylecode"
    t.string "ltstylecode"
    t.string "orderstylecode"
    t.string "rtmaterial"
    t.string "ltmaterial"
    t.string "ordermaterial"
    t.string "rtmaterialcode"
    t.string "ltmaterialcode"
    t.string "ordermaterialcode"
    t.string "rtpretreatment"
    t.string "ltpretreatment"
    t.string "orderpretreatment"
    t.string "rtpretreatmentcode"
    t.string "ltpretreatmentcode"
    t.string "orderpretreatmentcode"
    t.string "rtcolor"
    t.string "ltcolor"
    t.string "ordercolor"
    t.string "rtcolorcode"
    t.string "ltcolorcode"
    t.string "ordercolorcode"
    t.string "rtrequestedkind"
    t.string "ltrequestedkind"
    t.string "rtblanksforf"
    t.string "ltblanksforf"
    t.string "orderblanksforf"
    t.string "rtlnam"
    t.string "ltlnam"
    t.string "orderlnam"
    t.float "rtsphere"
    t.float "ltsphere"
    t.float "rtcylinder"
    t.float "ltcylinder"
    t.integer "rtaxis"
    t.integer "ltaxis"
    t.float "rtadd"
    t.float "ltadd"
    t.float "rtupperadd"
    t.float "ltupperadd"
    t.float "rtseght"
    t.float "ltseght"
    t.float "rtocht"
    t.float "ltocht"
    t.integer "rtwidth"
    t.integer "ltwidth"
    t.integer "rtdepth"
    t.integer "ltdepth"
    t.float "rtpd"
    t.float "ltpd"
    t.float "rtnearpd"
    t.float "ltnearpd"
    t.float "rtverticaldecent"
    t.float "ltverticaldecent"
    t.float "rtboc"
    t.float "ltboc"
    t.float "rtbsd"
    t.float "ltbsd"
    t.float "rtbsi"
    t.float "ltbsi"
    t.float "rtthick"
    t.float "ltthick"
    t.float "rtblankthick"
    t.float "ltblankthick"
    t.float "rtprism"
    t.float "ltprism"
    t.float "rtprism2"
    t.float "ltprism2"
    t.float "rtprismdirn"
    t.float "ltprismdirn"
    t.float "rtprismdirn2"
    t.float "ltprismdirn2"
    t.string "rtopc"
    t.string "ltopc"
    t.string "rtsku"
    t.string "ltsku"
    t.string "rtblankmanuf"
    t.string "ltblankmanuf"
    t.integer "rtblankdiam"
    t.integer "ltblankdiam"
    t.integer "rtbowlsize"
    t.integer "ltbowlsize"
    t.float "rtcarrier"
    t.float "ltcarrier"
    t.string "rtbinlocation"
    t.string "ltbinlocation"
    t.string "rtrequestedbase"
    t.string "ltrequestedbase"
    t.string "rtrequesteddiam"
    t.string "ltrequesteddiam"
    t.string "rtrequestedmanuf"
    t.string "ltrequestedmanuf"
    t.float "rtbasetool"
    t.float "ltbasetool"
    t.float "rtcrosstool"
    t.float "ltcrosstool"
    t.float "rtbasecurve"
    t.float "ltbasecurve"
    t.string "tracemodel"
    t.string "tracemanuf"
    t.string "tracesize"
    t.string "traceframetype"
    t.float "tracea"
    t.float "traceb"
    t.float "traceed"
    t.float "tracedbl"
    t.float "tracecirc"
    t.float "rtuncutdiam"
    t.float "ltuncutdiam"
    t.float "rtuncutellh"
    t.float "ltuncutellh"
    t.boolean "arflag"
    t.string "arcode"
    t.string "ardesc"
    t.decimal "arcost", precision: 12, scale: 3
    t.decimal "arprice", precision: 12, scale: 3
    t.boolean "tintflag"
    t.string "tintcode"
    t.string "tintdesc"
    t.decimal "tintcost", precision: 12, scale: 3
    t.decimal "tintprice", precision: 12, scale: 3
    t.boolean "mirrflag"
    t.string "mirrcode"
    t.string "mirrdesc"
    t.decimal "mirrcost", precision: 12, scale: 3
    t.decimal "mirrprice", precision: 12, scale: 3
    t.boolean "backflag"
    t.string "backcode"
    t.string "backdesc"
    t.decimal "backcost", precision: 12, scale: 3
    t.decimal "backprice", precision: 12, scale: 3
    t.boolean "polishflag"
    t.string "polishcode"
    t.string "polishdesc"
    t.decimal "polishcost", precision: 12, scale: 3
    t.decimal "polishprice", precision: 12, scale: 3
    t.boolean "polzflag"
    t.string "polzcode"
    t.string "polzdesc"
    t.decimal "polzcost", precision: 12, scale: 3
    t.decimal "polzprice", precision: 12, scale: 3
    t.boolean "photflag"
    t.string "photcode"
    t.string "photdesc"
    t.decimal "rtlenscost", precision: 12, scale: 3
    t.decimal "ltlenscost", precision: 12, scale: 3
    t.decimal "rtlensprice", precision: 12, scale: 3
    t.decimal "ltlensprice", precision: 12, scale: 3
    t.decimal "xtrapowerprice", precision: 12, scale: 3
    t.decimal "subtotal", precision: 12, scale: 3
    t.decimal "invoicetotal", precision: 12, scale: 3
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.decimal "digitalclickfee", precision: 12, scale: 3
    t.integer "numberdaysframereceived"
    t.decimal "totaladdonprice", precision: 12, scale: 3
    t.index ["arcode"], name: "index_orders_on_arcode"
    t.index ["arflag"], name: "index_orders_on_arflag"
    t.index ["backcode"], name: "index_orders_on_backcode"
    t.index ["backflag"], name: "index_orders_on_backflag"
    t.index ["datetimecompleted"], name: "index_orders_on_datetimecompleted"
    t.index ["datetimeframereceived"], name: "index_orders_on_datetimeframereceived"
    t.index ["datetimereceived"], name: "index_orders_on_datetimereceived"
    t.index ["hotjobflag"], name: "index_orders_on_hotjobflag"
    t.index ["invoicetotal"], name: "index_orders_on_invoicetotal"
    t.index ["jobtype"], name: "index_orders_on_jobtype"
    t.index ["ltopc"], name: "index_orders_on_ltopc"
    t.index ["mirrcode"], name: "index_orders_on_mirrcode"
    t.index ["mirrflag"], name: "index_orders_on_mirrflag"
    t.index ["orderblanksforf"], name: "index_orders_on_orderblanksforf"
    t.index ["ordercolorcode"], name: "index_orders_on_ordercolorcode"
    t.index ["orderdigitalvendor"], name: "index_orders_on_orderdigitalvendor"
    t.index ["orderlenstype"], name: "index_orders_on_orderlenstype"
    t.index ["orderlnam"], name: "index_orders_on_orderlnam"
    t.index ["ordermaterialcode"], name: "index_orders_on_ordermaterialcode"
    t.index ["ordernum", "labnum", "lmssource"], name: "index_orders_on_ordernum_and_labnum_and_lmssource", unique: true
    t.index ["orderpretreatmentcode"], name: "index_orders_on_orderpretreatmentcode"
    t.index ["orderstylecode"], name: "index_orders_on_orderstylecode"
    t.index ["polishcode"], name: "index_orders_on_polishcode"
    t.index ["polishflag"], name: "index_orders_on_polishflag"
    t.index ["polzcode"], name: "index_orders_on_polzcode"
    t.index ["polzflag"], name: "index_orders_on_polzflag"
    t.index ["remakecode"], name: "index_orders_on_remakecode"
    t.index ["rtopc"], name: "index_orders_on_rtopc"
    t.index ["subtotal"], name: "index_orders_on_subtotal"
    t.index ["tintcode"], name: "index_orders_on_tintcode"
    t.index ["tintflag"], name: "index_orders_on_tintflag"
  end

  create_table "po_headers", force: :cascade do |t|
    t.string "lmssource", null: false
    t.string "labnum", null: false
    t.string "ponum", null: false
    t.string "postatus"
    t.string "povendorid"
    t.string "povendorname"
    t.date "podate"
    t.decimal "pototal", precision: 12, scale: 2
    t.string "poreordermethod"
    t.string "potype"
    t.string "poopcfilename"
    t.string "poopcconfirmation"
    t.boolean "potransmitted"
    t.date "poclosedate"
    t.datetime "poreceivedate"
    t.integer "poqty"
    t.decimal "poamount", precision: 12, scale: 2
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.index ["labnum"], name: "index_po_headers_on_labnum"
    t.index ["poclosedate"], name: "index_po_headers_on_poclosedate"
    t.index ["podate"], name: "index_po_headers_on_podate"
    t.index ["ponum", "labnum", "lmssource"], name: "index_po_headers_on_ponum_and_labnum_and_lmssource", unique: true
    t.index ["poreceivedate"], name: "index_po_headers_on_poreceivedate"
    t.index ["postatus"], name: "index_po_headers_on_postatus"
    t.index ["potype"], name: "index_po_headers_on_potype"
    t.index ["povendorid"], name: "index_po_headers_on_povendorid"
  end

  create_table "po_lines", force: :cascade do |t|
    t.string "lensstocknum"
    t.integer "lensqtyonorder"
    t.integer "lensqtyonorderright"
    t.integer "lensqtyonorderleft"
    t.integer "lensqtyreceived"
    t.integer "lensqtyreceivedright"
    t.integer "lensqtyreceivedleft"
    t.integer "lensqtysuggested"
    t.integer "lensqtysuggestedright"
    t.integer "lensqtysuggestedleft"
    t.decimal "lensunitprice", precision: 12, scale: 3
    t.string "lensvendernumber"
    t.bigint "po_header_id"
    t.bigint "lens_id"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.index ["lens_id"], name: "index_po_lines_on_lens_id"
    t.index ["lensstocknum"], name: "index_po_lines_on_lensstocknum"
    t.index ["lensvendernumber"], name: "index_po_lines_on_lensvendernumber"
    t.index ["po_header_id"], name: "index_po_lines_on_po_header_id"
  end

  create_table "po_trays", force: :cascade do |t|
    t.string "poitemfortraynumber"
    t.bigint "po_line_id"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.index ["po_line_id"], name: "index_po_trays_on_po_line_id"
  end

  create_table "rx_module_logger_configs", force: :cascade do |t|
    t.string "location"
    t.string "level"
    t.integer "archive_count"
    t.integer "max_size"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
  end

  create_table "rx_module_update_histories", force: :cascade do |t|
    t.string "user"
    t.string "from_version"
    t.string "to_version"
    t.boolean "was_error"
    t.string "error_msg"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.boolean "in_progress"
    t.index ["created_at"], name: "index_rx_module_update_histories_on_created_at"
  end

  create_table "store_job_data", force: :cascade do |t|
    t.string "lmssource", null: false
    t.string "lenswarehouseid"
    t.date "lenswarehousedate", null: false
    t.integer "storedematrixlenses"
    t.integer "storedematrixbreak"
    t.integer "storedenonmatrixlenses"
    t.integer "storedenonmatrixbreak"
    t.integer "storedetotallenses"
    t.integer "storedetotalbreak"
    t.integer "storedesemifinlenses"
    t.integer "storedesemifinbreak"
    t.integer "storedefinlenses"
    t.integer "storedefinbreak"
    t.integer "storedecorpuncut"
    t.integer "storedecorpuncutbreak"
    t.integer "storedecorpedged"
    t.integer "storedecorpedgedbreak"
    t.integer "storejobscompletewithinv"
    t.integer "storejobscompletenoinv"
    t.integer "storejobsoutstandwithinv"
    t.integer "storejobsoutstandnoinv"
    t.integer "storetotaljobscompleted"
    t.integer "storetotaljobsoutstanding"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.index ["lenswarehousedate"], name: "index_store_job_data_on_lenswarehousedate"
    t.index ["lenswarehouseid", "lenswarehousedate", "lmssource"], name: "store_jobs_unique_key", unique: true
  end

  create_table "tax_charges", force: :cascade do |t|
    t.string "taxdesc"
    t.decimal "taxprice", precision: 12, scale: 3
    t.string "taxcode"
    t.bigint "order_id"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.index ["order_id"], name: "index_tax_charges_on_order_id"
    t.index ["taxcode"], name: "index_tax_charges_on_taxcode"
  end

  add_foreign_key "addon_charges", "orders", on_update: :cascade, on_delete: :cascade
  add_foreign_key "job_tracker_histories", "orders", on_update: :cascade, on_delete: :cascade
  add_foreign_key "lens_transactions", "lenses", on_update: :cascade, on_delete: :cascade
  add_foreign_key "lens_warehouse_data", "lenses", on_update: :cascade, on_delete: :cascade
  add_foreign_key "order_frames", "orders", on_update: :cascade, on_delete: :cascade
  add_foreign_key "order_remarks", "orders", on_update: :cascade, on_delete: :cascade
  add_foreign_key "order_stock_items", "orders", on_update: :cascade, on_delete: :cascade
  add_foreign_key "po_lines", "lenses", on_update: :cascade, on_delete: :nullify
  add_foreign_key "po_lines", "po_headers", on_update: :cascade, on_delete: :cascade
  add_foreign_key "po_trays", "po_lines", on_update: :cascade, on_delete: :cascade
  add_foreign_key "tax_charges", "orders", on_update: :cascade, on_delete: :cascade
end
